module     p0_ddbar_neepdubar_d13h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p0_ddbar_neepdubar/helicity0/d13h0l1.f90
   ! generator: haggies (1.1)
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_ddbar_neepdubar_groups, only: &
!           & sign => diagram13_sign, shift => diagram13_shift
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_abbrevd13h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d13
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k3+k6+k5+k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d13 = 0.0_ki
      t1 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t2 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t5 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t6 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))
      d13 = (abb13n2+t1*abb13n10+t2*abb13n3+t3*abb13n3+t4*abb13n3+t5*abb13n4+t6*&
      &abb13n5+abb13n6*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))+abb13n7*(Q(&
      &1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+abb13n&
      &8*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+abb13n9*(Q(1)*k1(1)-Q(2)*k1(2&
      &)-Q(3)*k1(3)-Q(4)*k1(4))+abb13n9*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k&
      &2(4))+t1*t2*abb13n12+t1*t3*abb13n12+t1*t4*abb13n12+t1*t5*abb13n14+t1*t6*a&
      &bb13n15+t1*abb13n11*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q&
      &(4)*spvak5k4(4))+t1*abb13n13*(Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spva&
      &k5k6(3)-Q(4)*spvak5k6(4)))
      numerator = cmplx(real(d13, ki), aimag(d13), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_abbrevd13h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d13
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k3+k6+k5+k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d13 = 0.0_ki
      t1 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t2 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t5 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t6 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))
      d13 = (abb13n2+t1*abb13n10+t2*abb13n3+t3*abb13n3+t4*abb13n3+t5*abb13n4+t6*&
      &abb13n5+abb13n6*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))+abb13n7*(Q(&
      &1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+abb13n&
      &8*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+abb13n9*(Q(1)*k1(1)-Q(2)*k1(2&
      &)-Q(3)*k1(3)-Q(4)*k1(4))+abb13n9*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k&
      &2(4))+t1*t2*abb13n12+t1*t3*abb13n12+t1*t4*abb13n12+t1*t5*abb13n14+t1*t6*a&
      &bb13n15+t1*abb13n11*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q&
      &(4)*spvak5k4(4))+t1*abb13n13*(Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spva&
      &k5k6(3)-Q(4)*spvak5k6(4)))

      numerator = cmplx(real(d13, ki), aimag(d13), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_ddbar_neepdubar_d13h0l1
