module     p0_ddbar_neepdubar_abbrevd59h1
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb59n1
   complex(ki), public :: abb59n2
   complex(ki), public :: rat2d59
   complex(ki), public :: abb59n4
   complex(ki), public :: abb59n5
   complex(ki), public :: abb59n6
   complex(ki), public :: abb59n7
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   real(ki) :: t8
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_ddbar_neepdubar_config, only: deltaOS
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_model
      use p0_ddbar_neepdubar_color, only: TR
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_*spak2k3
      t8 = TR*TR
      t3 = es234*NC*t1
      t4 = t8*t2/t3*spak2k5*spbk4k2*spbk6k1
      t2 = t8*t2/t3*spak3k5*spbk4k3*spbk6k1
      t3 = c2*i_*spak2k3
      t5 = t8*t3*spak2k5*spbk4k2*spbk6k1
      t1 = es234*t1
      t6 = t5/t1
      t3 = t8*t3*spak3k5*spbk4k3*spbk6k1
      t7 = t3/t1
      t1 = NC*NC*t1
      t5 = t5/t1
      t1 = t3/t1
      abb59n1 = ((16.0_ki)*(t2-t4)+(8.0_ki)*(t5+t6-(t7+t1)))
      abb59n2 = ((16.0_ki)*(t4-t2)+(8.0_ki)*(t1+t7-(t6+t5)))
      rat2d59 = 0
      rat2 = rat2 + rat2d59
      abb59n4 = -(abb59n1)
      abb59n5 = abb59n1
      abb59n6 = ((2.0_ki)*abb59n1)
      abb59n7 = -(abb59n2)
   end subroutine
end module p0_ddbar_neepdubar_abbrevd59h1
