module     p0_ddbar_neepdubar_abbrevd62h1
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb62n1
   complex(ki), public :: abb62n2
   complex(ki), public :: abb62n3
   complex(ki), public :: abb62n4
   complex(ki), public :: rat2d62
   complex(ki), public :: abb62n6
   complex(ki), public :: abb62n7
   complex(ki), public :: abb62n8
   complex(ki), public :: abb62n9
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   real(ki) :: t10
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_ddbar_neepdubar_config, only: deltaOS
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_model
      use p0_ddbar_neepdubar_color, only: TR
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_
      t3 = t2*spak2k6*spak3k5
      t10 = TR*TR
      t4 = es345*t1
      t5 = NC*NC*t4
      t6 = c2*i_
      t7 = t6*spak2k6*spak3k5
      t1 = es345*NC*t1
      t8 = NC*c2*i_
      t9 = t8*spak2k6*spak3k5
      abb62n1 = ((4.0_ki)*(t10*t3/t5*spbk5k4*spbk6k1+t10/t4*t9*spbk5k4*spbk6k1-t&
      &10*(2.0_ki)/t1*t7*spbk5k4*spbk6k1))
      abb62n2 = ((4.0_ki)*(t10*(2.0_ki)/t1*t7*spbk4k3*spbk6k1-(t10/t4*t9*spbk4k3&
      &*spbk6k1+t10*t3/t5*spbk4k3*spbk6k1)))
      t2 = t2*spak3k5
      t3 = t6*spak3k5
      t6 = t8*spak3k5
      abb62n3 = ((4.0_ki)*(t10*(2.0_ki)/t1*t3*spbk4k3-(t10/t4*t6*spbk4k3+t10*t2/&
      &t5*spbk4k3)))
      abb62n4 = ((4.0_ki)*(t10*t2/t5*spbk5k4+t10/t4*t6*spbk5k4-t10*(2.0_ki)/t1*t&
      &3*spbk5k4))
      rat2d62 = 0
      rat2 = rat2 + rat2d62
      abb62n6 = -(abb62n1)
      abb62n7 = abb62n4
      abb62n8 = abb62n3
      abb62n9 = -(abb62n2)
   end subroutine
end module p0_ddbar_neepdubar_abbrevd62h1
