module     p0_ddbar_neepdubar_d51h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p0_ddbar_neepdubar/helicity1/d51h1l1.f90
   ! generator: haggies (1.1)
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_ddbar_neepdubar_groups, only: &
!           & sign => diagram51_sign, shift => diagram51_shift
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_abbrevd51h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d51

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k6-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d51 = 0.0_ki
      d51 = (abb51n1+abb51n2*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)&
      &-Q(4)*spvak2k4(4))+abb51n3*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2&
      &k6(3)-Q(4)*spvak2k6(4))+abb51n4*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*s&
      &pvak5k4(3)-Q(4)*spvak5k4(4))+abb51n5*(Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(&
      &4)*k3(4))+abb51n5*(Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))+abb51n5*(&
      &Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+abb51n6*(Q(1)*spvak5k6(1)-Q(&
      &2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))+abb51n7*(Q(1)*spvak3k4(&
      &1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))+abb51n8*(Q(1)*spva&
      &k3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)))
      numerator = cmplx(real(d51, ki), aimag(d51), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_abbrevd51h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d51

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k6-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d51 = 0.0_ki
      d51 = (abb51n1+abb51n2*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)&
      &-Q(4)*spvak2k4(4))+abb51n3*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2&
      &k6(3)-Q(4)*spvak2k6(4))+abb51n4*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*s&
      &pvak5k4(3)-Q(4)*spvak5k4(4))+abb51n5*(Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(&
      &4)*k3(4))+abb51n5*(Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))+abb51n5*(&
      &Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+abb51n6*(Q(1)*spvak5k6(1)-Q(&
      &2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))+abb51n7*(Q(1)*spvak3k4(&
      &1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))+abb51n8*(Q(1)*spva&
      &k3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)))

      numerator = cmplx(real(d51, ki), aimag(d51), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_ddbar_neepdubar_d51h1l1
