module     p0_ddbar_neepdubar_d54h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p0_ddbar_neepdubar/helicity1/d54h1l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d54
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_abbrevd54h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb54n11+abb54n12*(spvak2k1(1)*qshift(1)-spvak2k1(2)*qshif&
         &t(2)-spvak2k1(3)*qshift(3)-spvak2k1(4)*qshift(4))+abb54n13*(spvak3k1(1&
         &)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-spvak3k1(4)*qs&
         &hift(4))+abb54n14*(spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k&
         &6(3)*qshift(3)-spvak2k6(4)*qshift(4))+abb54n15*dotproduct(k1, qshift)+&
         &abb54n16*dotproduct(k5, qshift)+abb54n16*dotproduct(k6, qshift)+abb54n&
         &17*(spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-&
         &spvak5k6(4)*qshift(4))+abb54n18*(spvak3k6(1)*qshift(1)-spvak3k6(2)*qsh&
         &ift(2)-spvak3k6(3)*qshift(3)-spvak3k6(4)*qshift(4))+abb54n19*(spvak5k1&
         &(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-spvak5k1(4)*&
         &qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb54n15+k5(iv1)*abb54n16+k6(iv1)*abb54n16+spvak2k&
         &1(iv1)*abb54n12+spvak2k6(iv1)*abb54n14+spvak3k1(iv1)*abb54n13+spvak3k6&
         &(iv1)*abb54n18+spvak5k1(iv1)*abb54n19+spvak5k6(iv1)*abb54n17)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d54:
   subroutine     reconstruct_d54(coeffs)
      use p0_ddbar_neepdubar_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_54:
      coeffs%coeffs_54%c0 = derivative(czip)
      coeffs%coeffs_54%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_54%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_54%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_54%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_54:
   end subroutine reconstruct_d54
!---#] subroutine reconstruct_d54:
end module p0_ddbar_neepdubar_d54h1l1d
