module     p1_ddbar_neepscbar_abbrevd32h0
   use p1_ddbar_neepscbar_config, only: ki
   use p1_ddbar_neepscbar_globalsh0
   implicit none
   private
   complex(ki), public :: abb32n1
   complex(ki), public :: abb32n2
   complex(ki), public :: abb32n3
   complex(ki), public :: abb32n4
   complex(ki), public :: abb32n5
   complex(ki), public :: abb32n6
   complex(ki), public :: abb32n7
   complex(ki), public :: abb32n8
   complex(ki), public :: abb32n9
   complex(ki), public :: abb32n10
   complex(ki), public :: abb32n11
   complex(ki), public :: abb32n12
   complex(ki), public :: rat2d32
   complex(ki), public :: abb32n14
   complex(ki), public :: abb32n15
   complex(ki), public :: abb32n16
   complex(ki), public :: abb32n17
   complex(ki), public :: abb32n18
   complex(ki), public :: abb32n19
   complex(ki), public :: abb32n20
   complex(ki), public :: abb32n21
   complex(ki), public :: abb32n22
   complex(ki), public :: abb32n23
   complex(ki), public :: abb32n24
   complex(ki), public :: abb32n25
   complex(ki), public :: abb32n26
   complex(ki), public :: abb32n27
   complex(ki), public :: abb32n28
   complex(ki), public :: abb32n29
   complex(ki), public :: abb32n30
   complex(ki), public :: abb32n31
   complex(ki), public :: abb32n32
   complex(ki), public :: abb32n33
   complex(ki), public :: abb32n34
   complex(ki), public :: abb32n35
   complex(ki), public :: abb32n36
   complex(ki), public :: abb32n37
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   real(ki) :: t13
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p1_ddbar_neepscbar_config, only: deltaOS
      use p1_ddbar_neepscbar_kinematics
      use p1_ddbar_neepscbar_model
      use p1_ddbar_neepscbar_color, only: TR
      use p1_ddbar_neepscbar_globalsl1, only: epspow
      implicit none
      t1 = c2*i_
      t2 = t1*spak1k3
      t13 = TR*TR
      t3 = (es12+es34-(es56+es345))*(es34+wW*mW*i_-mW*mW)
      t4 = NC*t3
      t5 = c1*i_
      t6 = t5*spak1k3
      t7 = NC*NC*t3
      t8 = NC*c2*i_
      t9 = t8*spak1k3
      abb32n1 = ((8.0_ki)*(t13*t2/t4*spbk4k3-t13*t1/t4*spak1k6*spbk6k4)+(4.0_ki)&
      &*(t13/t3*t8*spak1k6*spbk6k4+t13*t5/t7*spak1k6*spbk6k4-(t13*t6/t7*spbk4k3+&
      &t13/t3*t9*spbk4k3)))
      abb32n2 = ((8.0_ki)*((2.0_ki)*t13*t2/t4*spbk6k4-(t13*t6/t7*spbk6k4+t13/t3*&
      &t9*spbk6k4)))
      abb32n3 = ((8.0_ki)*(-(t13*t1/t4*spak1k4*spbk6k4+t13*t2/t4*spbk6k3))+(4.0_&
      &ki)*(t13/t3*t9*spbk6k3+t13*t6/t7*spbk6k3+t13/t3*t8*spak1k4*spbk6k4+t13*t5&
      &/t7*spak1k4*spbk6k4))
      t2 = t1*spak1k5
      t6 = t13*t2/t4*spak3k4*spbk4k2*spbk6k4
      t2 = t13*t2/t4*spak3k6*spbk6k2*spbk6k4
      t9 = t5*spak1k5
      t10 = t13/t7*t9*spak3k4*spbk4k2*spbk6k4
      t9 = t13/t7*t9*spak3k6*spbk6k2*spbk6k4
      t11 = t8*spak1k5
      t12 = t13*t11/t3*spak3k4*spbk4k2*spbk6k4
      t11 = t13*t11/t3*spak3k6*spbk6k2*spbk6k4
      abb32n4 = ((16.0_ki)*(-(t6+t2))+(8.0_ki)*(t10+t11+t12+t9))
      abb32n5 = ((16.0_ki)*(t2+t6)+(8.0_ki)*(-(t9+t12+t11+t10)))
      t2 = t13*t5/t7*spak3k4*spbk6k4
      t6 = t13*(2.0_ki)*t1/t4*spak3k4*spbk6k4
      t9 = t13/t3*t8*spak3k4*spbk6k4
      abb32n6 = ((4.0_ki)*(t2+t9-t6))
      abb32n7 = ((4.0_ki)*(t6-(t9+t2)))
      t2 = t5*spak3k5
      t6 = t1*spak3k5
      t9 = t8*spak3k5
      abb32n8 = ((8.0_ki)*((2.0_ki)*t13/t4*t6*spbk6k4-(t13/t3*t9*spbk6k4+t13*t2/&
      &t7*spbk6k4)))
      t10 = t13*t5/t7*spak3k6*spbk6k4
      t11 = t13*(2.0_ki)*t1/t4*spak3k6*spbk6k4
      t12 = t13/t3*t8*spak3k6*spbk6k4
      abb32n9 = ((4.0_ki)*(t10+t12-t11))
      abb32n10 = ((4.0_ki)*(t11-(t12+t10)))
      abb32n11 = ((8.0_ki)*(-(t13*t1/t4*spak4k5*spbk6k4+t13/t4*t6*spbk6k3))+(4.0&
      &_ki)*(t13*t2/t7*spbk6k3+t13/t3*t9*spbk6k3+t13/t3*t8*spak4k5*spbk6k4+t13*t&
      &5/t7*spak4k5*spbk6k4))
      abb32n12 = ((8.0_ki)*(t13/t4*t6*spbk4k3+t13*t1/t4*spak5k6*spbk6k4)+(4.0_ki&
      &)*(-(t13*t5/t7*spak5k6*spbk6k4+t13/t3*t8*spak5k6*spbk6k4+t13/t3*t9*spbk4k&
      &3+t13*t2/t7*spbk4k3)))
      rat2d32 = 0
      rat2 = rat2 + rat2d32
      abb32n14 = abb32n1
      abb32n15 = abb32n12
      abb32n16 = abb32n11
      abb32n17 = abb32n10
      abb32n18 = abb32n9
      abb32n19 = abb32n8
      abb32n20 = abb32n7
      abb32n21 = abb32n6
      abb32n22 = abb32n5
      abb32n23 = abb32n4
      abb32n24 = abb32n3
      abb32n25 = abb32n2
      abb32n26 = -(abb32n1)
      abb32n27 = -(abb32n2)
      abb32n28 = -(abb32n3)
      abb32n29 = -(abb32n4)
      abb32n30 = -(abb32n5)
      abb32n31 = -(abb32n6)
      abb32n32 = -(abb32n7)
      abb32n33 = -(abb32n8)
      abb32n34 = -(abb32n9)
      abb32n35 = -(abb32n10)
      abb32n36 = -(abb32n11)
      abb32n37 = -(abb32n12)
   end subroutine
end module p1_ddbar_neepscbar_abbrevd32h0
