module     p1_ddbar_neepscbar_abbrevd33h0
   use p1_ddbar_neepscbar_config, only: ki
   use p1_ddbar_neepscbar_globalsh0
   implicit none
   private
   complex(ki), public :: abb33n1
   complex(ki), public :: abb33n2
   complex(ki), public :: abb33n3
   complex(ki), public :: abb33n4
   complex(ki), public :: abb33n5
   complex(ki), public :: abb33n6
   complex(ki), public :: abb33n7
   complex(ki), public :: abb33n8
   complex(ki), public :: abb33n9
   complex(ki), public :: abb33n10
   complex(ki), public :: rat2d33
   complex(ki), public :: abb33n12
   complex(ki), public :: abb33n13
   complex(ki), public :: abb33n14
   complex(ki), public :: abb33n15
   complex(ki), public :: abb33n16
   complex(ki), public :: abb33n17
   complex(ki), public :: abb33n18
   complex(ki), public :: abb33n19
   complex(ki), public :: abb33n20
   complex(ki), public :: abb33n21
   complex(ki), public :: abb33n22
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   real(ki) :: t13
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p1_ddbar_neepscbar_config, only: deltaOS
      use p1_ddbar_neepscbar_kinematics
      use p1_ddbar_neepscbar_model
      use p1_ddbar_neepscbar_color, only: TR
      use p1_ddbar_neepscbar_globalsl1, only: epspow
      implicit none
      t1 = c1*i_
      t2 = t1*spak1k5
      t3 = t2*spak3k6
      t13 = TR*TR
      t4 = t13*t3*spbk5k2*spbk6k4
      t5 = (es12+es34-(es56+es345))*(es34+wW*mW*i_-mW*mW)
      t6 = NC*NC*t5
      t7 = c2*i_
      t8 = t7*spak1k5
      t9 = t8*spak3k6
      t10 = NC*t5
      abb33n1 = ((4.0_ki)*(t4/t5+t4/t6-t13*(2.0_ki)/t10*t9*spbk5k2*spbk6k4))
      t4 = t2*spak3k4
      t11 = t13*t4*spbk5k2*spbk6k4
      t12 = t8*spak3k4
      abb33n2 = ((4.0_ki)*(t11/t5+t11/t6-t13*(2.0_ki)/t10*t12*spbk5k2*spbk6k4))
      t4 = t13*t4*spbk4k2*spbk6k4
      t3 = t13*t3*spbk6k2*spbk6k4
      abb33n3 = ((8.0_ki)*(-(t13/t10*t9*spbk6k2*spbk6k4+t13*t12/t10*spbk4k2*spbk&
      &6k4))+(4.0_ki)*(t3/t5+t3/t6+t4/t5+t4/t6))
      t3 = t13*t2*spbk4k3
      abb33n4 = ((4.0_ki)*(t13*(2.0_ki)/t10*t8*spbk4k3-(t3/t6+t3/t5)))
      t3 = t13*t2*spbk6k3
      abb33n5 = ((4.0_ki)*(t3/t5+t3/t6-t13*(2.0_ki)/t10*t8*spbk6k3))
      t2 = t13*t2*spbk6k4
      t3 = t2/t5
      t2 = t2/t6
      t4 = t13*(2.0_ki)/t10*t8*spbk6k4
      abb33n6 = ((4.0_ki)*(t2+t3-t4))
      abb33n7 = ((8.0_ki)*(t4-(t3+t2)))
      t2 = t1*spak3k5
      t3 = t13*t2*spbk6k4
      t4 = t7*spak3k5
      abb33n8 = ((8.0_ki)*(t3/t5+t3/t6-t13*(2.0_ki)/t10*t4*spbk6k4))
      t3 = t13*t2*spbk6k3
      t8 = t13*t1*spak4k5*spbk6k4
      abb33n9 = ((8.0_ki)*(t13/t10*t4*spbk6k3+t13/t10*t7*spak4k5*spbk6k4)+(4.0_k&
      &i)*(-(t8/t6+t8/t5+t3/t6+t3/t5)))
      t2 = t13*t2*spbk4k3
      t1 = t13*t1*spak5k6*spbk6k4
      abb33n10 = ((8.0_ki)*(-(t13/t10*t7*spak5k6*spbk6k4+t13/t10*t4*spbk4k3))+(4&
      &.0_ki)*(t1/t5+t1/t6+t2/t5+t2/t6))
      rat2d33 = 0
      rat2 = rat2 + rat2d33
      abb33n12 = -(abb33n1)
      abb33n13 = abb33n10
      abb33n14 = abb33n9
      abb33n15 = abb33n8
      abb33n16 = abb33n7
      abb33n17 = abb33n6
      abb33n18 = abb33n5
      abb33n19 = abb33n4
      abb33n20 = abb33n3
      abb33n21 = -(abb33n2)
      abb33n22 = ((2.0_ki)*abb33n3)
   end subroutine
end module p1_ddbar_neepscbar_abbrevd33h0
