module     p1_ddbar_neepscbar_abbrevd31h1
   use p1_ddbar_neepscbar_config, only: ki
   use p1_ddbar_neepscbar_globalsh1
   implicit none
   private
   complex(ki), public :: abb31n1
   complex(ki), public :: abb31n2
   complex(ki), public :: abb31n3
   complex(ki), public :: abb31n4
   complex(ki), public :: rat2d31
   complex(ki), public :: abb31n6
   complex(ki), public :: abb31n7
   complex(ki), public :: abb31n8
   complex(ki), public :: abb31n9
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   real(ki) :: t10
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p1_ddbar_neepscbar_config, only: deltaOS
      use p1_ddbar_neepscbar_kinematics
      use p1_ddbar_neepscbar_model
      use p1_ddbar_neepscbar_color, only: TR
      use p1_ddbar_neepscbar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_
      t3 = t2*spak2k6*spak3k5
      t10 = TR*TR
      t4 = es345*t1
      t5 = NC*NC*t4
      t6 = c2*i_
      t7 = t6*spak2k6*spak3k5
      t1 = es345*NC*t1
      t8 = NC*c2*i_
      t9 = t8*spak2k6*spak3k5
      abb31n1 = ((4.0_ki)*(t10*t3/t5*spbk5k4*spbk6k1+t10/t4*t9*spbk5k4*spbk6k1-t&
      &10*(2.0_ki)/t1*t7*spbk5k4*spbk6k1))
      abb31n2 = ((4.0_ki)*(t10*(2.0_ki)/t1*t7*spbk4k3*spbk6k1-(t10/t4*t9*spbk4k3&
      &*spbk6k1+t10*t3/t5*spbk4k3*spbk6k1)))
      t2 = t2*spak3k5
      t3 = t6*spak3k5
      t6 = t8*spak3k5
      abb31n3 = ((4.0_ki)*(t10*(2.0_ki)/t1*t3*spbk4k3-(t10/t4*t6*spbk4k3+t10*t2/&
      &t5*spbk4k3)))
      abb31n4 = ((4.0_ki)*(t10*t2/t5*spbk5k4+t10/t4*t6*spbk5k4-t10*(2.0_ki)/t1*t&
      &3*spbk5k4))
      rat2d31 = 0
      rat2 = rat2 + rat2d31
      abb31n6 = -(abb31n1)
      abb31n7 = abb31n4
      abb31n8 = abb31n3
      abb31n9 = -(abb31n2)
   end subroutine
end module p1_ddbar_neepscbar_abbrevd31h1
