module     p1_ddbar_neepscbar_abbrevd32h1
   use p1_ddbar_neepscbar_config, only: ki
   use p1_ddbar_neepscbar_globalsh1
   implicit none
   private
   complex(ki), public :: abb32n1
   complex(ki), public :: abb32n2
   complex(ki), public :: abb32n3
   complex(ki), public :: abb32n4
   complex(ki), public :: abb32n5
   complex(ki), public :: abb32n6
   complex(ki), public :: abb32n7
   complex(ki), public :: abb32n8
   complex(ki), public :: abb32n9
   complex(ki), public :: rat2d32
   complex(ki), public :: abb32n11
   complex(ki), public :: abb32n12
   complex(ki), public :: abb32n13
   complex(ki), public :: abb32n14
   complex(ki), public :: abb32n15
   complex(ki), public :: abb32n16
   complex(ki), public :: abb32n17
   complex(ki), public :: abb32n18
   complex(ki), public :: abb32n19
   complex(ki), public :: abb32n20
   complex(ki), public :: abb32n21
   complex(ki), public :: abb32n22
   complex(ki), public :: abb32n23
   complex(ki), public :: abb32n24
   complex(ki), public :: abb32n25
   complex(ki), public :: abb32n26
   complex(ki), public :: abb32n27
   complex(ki), public :: abb32n28
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   real(ki) :: t13
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p1_ddbar_neepscbar_config, only: deltaOS
      use p1_ddbar_neepscbar_kinematics
      use p1_ddbar_neepscbar_model
      use p1_ddbar_neepscbar_color, only: TR
      use p1_ddbar_neepscbar_globalsl1, only: epspow
      implicit none
      t1 = c2*i_
      t2 = t1*spak2k5
      t3 = t2*spak3k4
      t13 = TR*TR
      t4 = (es12+es34-(es56+es345))*(es34+wW*mW*i_-mW*mW)
      t5 = NC*t4
      t2 = t2*spak3k6
      t6 = c1*i_
      t7 = t6*spak2k5
      t8 = t7*spak3k4
      t9 = NC*NC*t4
      t7 = t7*spak3k6
      t10 = NC*c2*i_
      t11 = t10*spak2k5
      t12 = t11*spak3k4
      t11 = t11*spak3k6
      abb32n1 = ((8.0_ki)*(t13*t3/t5*spbk5k4*spbk6k4-t13*t2/t5*spbk6k4*spbk6k5)+&
      &(4.0_ki)*(t13*t11/t4*spbk6k4*spbk6k5+t13*t7/t9*spbk6k4*spbk6k5-(t13*t8/t9&
      &*spbk5k4*spbk6k4+t13*t12/t4*spbk5k4*spbk6k4)))
      abb32n2 = ((16.0_ki)*(t13*t2/t5*spbk6k1*spbk6k4+t13*t3/t5*spbk4k1*spbk6k4)&
      &+(8.0_ki)*(-(t13*t8/t9*spbk4k1*spbk6k4+t13*t7/t9*spbk6k1*spbk6k4+t13*t12/&
      &t4*spbk4k1*spbk6k4+t13*t11/t4*spbk6k1*spbk6k4)))
      t2 = t6*spak2k3
      t3 = t1*spak2k3
      t7 = t10*spak2k3
      abb32n3 = ((8.0_ki)*(t13*t2/t9*spbk6k4+t13/t4*t7*spbk6k4-(2.0_ki)*t13*t3/t&
      &5*spbk6k4))
      abb32n4 = ((8.0_ki)*(t13*t3/t5*spbk6k3+t13*t1/t5*spak2k4*spbk6k4)+(4.0_ki)&
      &*(-(t13*t6/t9*spak2k4*spbk6k4+t13*t10/t4*spak2k4*spbk6k4+t13/t4*t7*spbk6k&
      &3+t13*t2/t9*spbk6k3)))
      abb32n5 = ((8.0_ki)*(t13*t1/t5*spak2k6*spbk6k4-t13*t3/t5*spbk4k3)+(4.0_ki)&
      &*(t13*t2/t9*spbk4k3+t13/t4*t7*spbk4k3-(t13*t6/t9*spak2k6*spbk6k4+t13*t10/&
      &t4*spak2k6*spbk6k4)))
      t2 = t13*t6/t9*spak3k4*spbk6k4
      t3 = t13*(2.0_ki)*t1/t5*spak3k4*spbk6k4
      t7 = t13*t10/t4*spak3k4*spbk6k4
      abb32n6 = ((4.0_ki)*(t2+t7-t3))
      abb32n7 = ((4.0_ki)*(t3-(t7+t2)))
      t2 = t13*t6/t9*spak3k6*spbk6k4
      t1 = t13*(2.0_ki)*t1/t5*spak3k6*spbk6k4
      t3 = t13*t10/t4*spak3k6*spbk6k4
      abb32n8 = ((4.0_ki)*(t2+t3-t1))
      abb32n9 = ((4.0_ki)*(t1-(t3+t2)))
      rat2d32 = 0
      rat2 = rat2 + rat2d32
      abb32n11 = -(abb32n1)
      abb32n12 = abb32n9
      abb32n13 = abb32n8
      abb32n14 = abb32n7
      abb32n15 = abb32n6
      abb32n16 = abb32n5
      abb32n17 = abb32n4
      abb32n18 = abb32n3
      abb32n19 = abb32n2
      abb32n20 = abb32n1
      abb32n21 = -(abb32n2)
      abb32n22 = -(abb32n3)
      abb32n23 = -(abb32n4)
      abb32n24 = -(abb32n5)
      abb32n25 = -(abb32n6)
      abb32n26 = -(abb32n7)
      abb32n27 = -(abb32n8)
      abb32n28 = -(abb32n9)
   end subroutine
end module p1_ddbar_neepscbar_abbrevd32h1
