module     p1_ddbar_neepscbar_d2h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p1_ddbar_neepscbar/helicity1/d2h1l1.f90
   ! generator: haggies (1.1)
   use p1_ddbar_neepscbar_config, only: ki
   use p1_ddbar_neepscbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p1_ddbar_neepscbar_groups, only: &
!           & sign => diagram2_sign, shift => diagram2_shift
      use p1_ddbar_neepscbar_globalsl1, only: epspow
      use p1_ddbar_neepscbar_kinematics
      use p1_ddbar_neepscbar_abbrevd2h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d2
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(-Q_ext(4),   ki_sam), aimag(-Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3), ki_sam), aimag(-Q_ext(1:3)), ki)
      d2 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t4 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t5 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t6 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))
      t7 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t8 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t9 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))
      t10 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      d2 = (abb2n1+t1*abb2n11+t2*abb2n13+t3*abb2n13+t4*abb2n14+t5*abb2n15+t6*abb&
      &2n16+t7*abb2n18+t8*abb2n2+t9*abb2n3+t1*t7*abb2n24+t1*t8*abb2n12+t10*t2*ab&
      &b2n21+t10*t3*abb2n21+t10*t4*abb2n19+t10*t5*abb2n20+t10*t7*abb2n4+t10*t8*a&
      &bb2n23+t2*t6*abb2n7+t2*t9*abb2n8+t3*t6*abb2n7+t3*t9*abb2n8+t4*t6*abb2n5+t&
      &4*t7*abb2n25+t4*t8*abb2n17+t4*t9*abb2n10+t5*t6*abb2n6+t5*t7*abb2n26+t5*t9&
      &*abb2n9+t6*t7*abb2n27+t7*t9*abb2n22+t7*abb2n20*(Q(1)*spvak5k2(1)-Q(2)*spv&
      &ak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+t7*abb2n9*(Q(1)*spvak1k6(1)-Q&
      &(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4))+t1*t7*t8*abb2n28)
      numerator = cmplx(real(d2, ki), aimag(d2), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p1_ddbar_neepscbar_globalsl1, only: epspow
      use p1_ddbar_neepscbar_kinematics
      use p1_ddbar_neepscbar_abbrevd2h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d2
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(-Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d2 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t4 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t5 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t6 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))
      t7 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t8 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t9 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))
      t10 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      d2 = (abb2n1+t1*abb2n11+t2*abb2n13+t3*abb2n13+t4*abb2n14+t5*abb2n15+t6*abb&
      &2n16+t7*abb2n18+t8*abb2n2+t9*abb2n3+t1*t7*abb2n24+t1*t8*abb2n12+t10*t2*ab&
      &b2n21+t10*t3*abb2n21+t10*t4*abb2n19+t10*t5*abb2n20+t10*t7*abb2n4+t10*t8*a&
      &bb2n23+t2*t6*abb2n7+t2*t9*abb2n8+t3*t6*abb2n7+t3*t9*abb2n8+t4*t6*abb2n5+t&
      &4*t7*abb2n25+t4*t8*abb2n17+t4*t9*abb2n10+t5*t6*abb2n6+t5*t7*abb2n26+t5*t9&
      &*abb2n9+t6*t7*abb2n27+t7*t9*abb2n22+t7*abb2n20*(Q(1)*spvak5k2(1)-Q(2)*spv&
      &ak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+t7*abb2n9*(Q(1)*spvak1k6(1)-Q&
      &(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4))+t1*t7*t8*abb2n28)

      numerator = cmplx(real(d2, ki), aimag(d2), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p1_ddbar_neepscbar_d2h1l1
