module     p7_udbar_neepuubar_d59h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p7_udbar_neepuubar/helicity0/d59h0l1.f90
   ! generator: haggies (1.1)
   use p7_udbar_neepuubar_config, only: ki
   use p7_udbar_neepuubar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p7_udbar_neepuubar_groups, only: &
!           & sign => diagram59_sign, shift => diagram59_shift
      use p7_udbar_neepuubar_globalsl1, only: epspow
      use p7_udbar_neepuubar_kinematics
      use p7_udbar_neepuubar_abbrevd59h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d59
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(-Q_ext(4),   ki_sam), aimag(-Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3), ki_sam), aimag(-Q_ext(1:3)), ki)
      d59 = 0.0_ki
      t1 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t6 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t7 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      d59 = (abb59n1+t1*abb59n7+abb59n2*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*&
      &spvak2k1(3)-Q(4)*spvak2k1(4))+abb59n8*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-&
      &Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+abb59n9*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)&
      &-Q(4)*Q(4))+t1*t2*abb59n5+t1*t4*abb59n6+t1*t5*abb59n14+t1*t6*abb59n4+t1*t&
      &7*abb59n4+t2*t3*abb59n10+t3*t4*abb59n3+t3*t5*abb59n15+t3*t6*abb59n13+t3*t&
      &7*abb59n13+t4*abb59n11*(Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3&
      &)-Q(4)*spvak4k5(4))+t5*abb59n12*(Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*s&
      &pvak1k5(3)-Q(4)*spvak1k5(4)))
      numerator = cmplx(real(d59, ki), aimag(d59), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p7_udbar_neepuubar_globalsl1, only: epspow
      use p7_udbar_neepuubar_kinematics
      use p7_udbar_neepuubar_abbrevd59h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d59
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(-Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d59 = 0.0_ki
      t1 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t6 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t7 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      d59 = (abb59n1+t1*abb59n7+abb59n2*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*&
      &spvak2k1(3)-Q(4)*spvak2k1(4))+abb59n8*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-&
      &Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+abb59n9*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)&
      &-Q(4)*Q(4))+t1*t2*abb59n5+t1*t4*abb59n6+t1*t5*abb59n14+t1*t6*abb59n4+t1*t&
      &7*abb59n4+t2*t3*abb59n10+t3*t4*abb59n3+t3*t5*abb59n15+t3*t6*abb59n13+t3*t&
      &7*abb59n13+t4*abb59n11*(Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3&
      &)-Q(4)*spvak4k5(4))+t5*abb59n12*(Q(1)*spvak1k5(1)-Q(2)*spvak1k5(2)-Q(3)*s&
      &pvak1k5(3)-Q(4)*spvak1k5(4)))

      numerator = cmplx(real(d59, ki), aimag(d59), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p7_udbar_neepuubar_d59h0l1
