module     p7_udbar_neepuubar_d52h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p7_udbar_neepuubar/helicity1/d52h1l1.f90
   ! generator: haggies (1.1)
   use p7_udbar_neepuubar_config, only: ki
   use p7_udbar_neepuubar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p7_udbar_neepuubar_groups, only: &
!           & sign => diagram52_sign, shift => diagram52_shift
      use p7_udbar_neepuubar_globalsl1, only: epspow
      use p7_udbar_neepuubar_kinematics
      use p7_udbar_neepuubar_abbrevd52h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d52

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d52 = 0.0_ki
      d52 = (abb52n1+abb52n2*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)&
      &-Q(4)*spvak2k1(4))+abb52n3*(Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3&
      &k1(3)-Q(4)*spvak3k1(4))+abb52n4*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*s&
      &pvak2k6(3)-Q(4)*spvak2k6(4))+abb52n5*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(&
      &4)*k1(4))+abb52n6*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))+abb52n6*(&
      &Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+abb52n7*(Q(1)*spvak5k6(1)-Q(&
      &2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))+abb52n8*(Q(1)*spvak3k6(&
      &1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))+abb52n9*(Q(1)*spva&
      &k5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)))
      numerator = cmplx(real(d52, ki), aimag(d52), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p7_udbar_neepuubar_globalsl1, only: epspow
      use p7_udbar_neepuubar_kinematics
      use p7_udbar_neepuubar_abbrevd52h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d52

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d52 = 0.0_ki
      d52 = (abb52n1+abb52n2*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)&
      &-Q(4)*spvak2k1(4))+abb52n3*(Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3&
      &k1(3)-Q(4)*spvak3k1(4))+abb52n4*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*s&
      &pvak2k6(3)-Q(4)*spvak2k6(4))+abb52n5*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(&
      &4)*k1(4))+abb52n6*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))+abb52n6*(&
      &Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+abb52n7*(Q(1)*spvak5k6(1)-Q(&
      &2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))+abb52n8*(Q(1)*spvak3k6(&
      &1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))+abb52n9*(Q(1)*spva&
      &k5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)))

      numerator = cmplx(real(d52, ki), aimag(d52), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p7_udbar_neepuubar_d52h1l1
