module     p7_udbar_neepuubar_d8h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p7_udbar_neepuubar/helicity1/d8h1l1d.f90
   ! generator: haggies (1.1)
   use p7_udbar_neepuubar_config, only: ki
   use p7_udbar_neepuubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d8
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p7_udbar_neepuubar_globalsl1, only: epspow
      use p7_udbar_neepuubar_kinematics
      use p7_udbar_neepuubar_abbrevd8h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(deg.eq.0) then
         numerator = (0.0_ki)
         return
      end if
      t1 = spvak3k4(iv1)
      if(deg.eq.1) then
         numerator = (k3(iv1)*abb8n21+k4(iv1)*abb8n21+spvak2k4(iv1)*abb8n16+t1*a&
         &bb8n13)
         return
      end if
      t2 = spvak3k4(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb8n20+k1(iv1)*t2*abb8n18+k1(iv2)*t1*&
         &abb8n18+k5(iv1)*t2*abb8n19+k5(iv2)*t1*abb8n19+k6(iv1)*t2*abb8n19+k6(iv&
         &2)*t1*abb8n19+spvak2k1(iv1)*t2*abb8n22+spvak2k1(iv2)*t1*abb8n22+spvak2&
         &k6(iv1)*t2*abb8n15+spvak2k6(iv2)*t1*abb8n15+spvak5k1(iv1)*t2*abb8n14+s&
         &pvak5k1(iv2)*t1*abb8n14+spvak5k6(iv1)*t2*abb8n17+spvak5k6(iv2)*t1*abb8&
         &n17)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d8:
   subroutine     reconstruct_d8(coeffs)
      use p7_udbar_neepuubar_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_8:
      coeffs%coeffs_8%c0 = derivative(czip)
      coeffs%coeffs_8%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_8%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_8%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_8%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_8%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_8%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_8%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_8%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_8%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_8%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_8%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_8%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_8%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_8%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_8:
   end subroutine reconstruct_d8
!---#] subroutine reconstruct_d8:
end module p7_udbar_neepuubar_d8h1l1d
