module     p8_udbar_neepssbar_abbrevd33h0
   use p8_udbar_neepssbar_config, only: ki
   use p8_udbar_neepssbar_globalsh0
   implicit none
   private
   complex(ki), public :: abb33n1
   complex(ki), public :: abb33n2
   complex(ki), public :: abb33n3
   complex(ki), public :: abb33n4
   complex(ki), public :: abb33n5
   complex(ki), public :: rat2d33
   complex(ki), public :: abb33n7
   complex(ki), public :: abb33n8
   complex(ki), public :: abb33n9
   complex(ki), public :: abb33n10
   complex(ki), public :: abb33n11
   complex(ki), public :: abb33n12
   complex(ki), public :: abb33n13
   complex(ki), public :: abb33n14
   complex(ki), public :: abb33n15
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   real(ki) :: t14
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p8_udbar_neepssbar_config, only: deltaOS
      use p8_udbar_neepssbar_kinematics
      use p8_udbar_neepssbar_model
      use p8_udbar_neepssbar_color, only: TR
      use p8_udbar_neepssbar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = es61*c2*i_*spak2k3
      t14 = TR*TR
      t3 = es234*NC*t1
      t4 = es61*c1*i_*spak2k3
      t5 = t14*t4*spak2k6*spbk4k2*spbk5k1
      t1 = es234*t1
      t4 = t14*t4*spak3k6*spbk4k3*spbk5k1
      t6 = NC*NC*t1
      abb33n1 = ((8.0_ki)*(t14*t2/t3*spak2k6*spbk4k2*spbk5k1-t14*t2/t3*spak3k6*s&
      &pbk4k3*spbk5k1)+(4.0_ki)*(t4/t1+t4/t6-(t5/t6+t5/t1)))
      t2 = c2*i_
      t4 = t2*spak2k3
      t5 = t4*spak2k6*spbk4k2
      t7 = t4*spak3k6*spbk4k3
      t8 = c1*i_
      t9 = t8*spak2k3
      t10 = t9*spak2k6*spbk4k2
      t11 = t14*t10*spbk5k1
      t12 = t9*spak3k6*spbk4k3
      t13 = t14*t12*spbk5k1
      abb33n2 = ((16.0_ki)*(t14/t3*t7*spbk5k1-t14/t3*t5*spbk5k1)+(8.0_ki)*(t11/t&
      &1+t11/t6-(t13/t6+t13/t1)))
      t11 = t14*t9*spbk4k2
      abb33n3 = ((4.0_ki)*(t11/t1+t11/t6-(2.0_ki)*t14/t3*t4*spbk4k2))
      t11 = t14*t8*spak1k2*spak2k3*spbk4k2*spbk5k1
      t8 = t14*t8*spak1k3*spak2k3*spbk4k3*spbk5k1
      t10 = t14*t10*spbk6k5
      t12 = t14*t12*spbk6k5
      abb33n4 = ((8.0_ki)*(t14/t3*t7*spbk6k5+t14*t2/t3*spak1k3*spak2k3*spbk4k3*s&
      &pbk5k1-(t14*t2/t3*spak1k2*spak2k3*spbk4k2*spbk5k1+t14/t3*t5*spbk6k5))+(4.&
      &0_ki)*(t10/t1+t11/t1+t10/t6+t11/t6-(t8/t6+t12/t6+t8/t1+t12/t1)))
      t2 = t14*t9*spbk4k3
      abb33n5 = ((4.0_ki)*((2.0_ki)*t14/t3*t4*spbk4k3-(t2/t6+t2/t1)))
      rat2d33 = 0
      rat2 = rat2 + rat2d33
      abb33n7 = abb33n1
      abb33n8 = abb33n5
      abb33n9 = abb33n4
      abb33n10 = abb33n3
      abb33n11 = abb33n2
      abb33n12 = -(abb33n2)
      abb33n13 = -(abb33n3)
      abb33n14 = -(abb33n4)
      abb33n15 = -(abb33n5)
   end subroutine
end module p8_udbar_neepssbar_abbrevd33h0
