module     p8_udbar_neepssbar_d1h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p8_udbar_neepssbar/helicity0/d1h0l1.f90
   ! generator: haggies (1.1)
   use p8_udbar_neepssbar_config, only: ki
   use p8_udbar_neepssbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p8_udbar_neepssbar_groups, only: &
!           & sign => diagram1_sign, shift => diagram1_shift
      use p8_udbar_neepssbar_globalsl1, only: epspow
      use p8_udbar_neepssbar_kinematics
      use p8_udbar_neepssbar_abbrevd1h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d1
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3+k2-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d1 = 0.0_ki
      t1 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t4 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t5 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t6 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t7 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t8 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t9 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t12 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      d1 = (t1*abb1n1+t10*abb1n6+t11*abb1n7+t2*abb1n12+t3*abb1n16+t4*abb1n17+t5*&
      &abb1n2+t6*abb1n5+t7*abb1n5+t8*abb1n6+t9*abb1n6+abb1n18*(Q(1)*spvak5k1(1)-&
      &Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))+t1*t11*abb1n8+t1*t12*&
      &abb1n13+t1*t2*abb1n4+t1*t6*abb1n3+t1*t7*abb1n3+t10*t12*abb1n11+t12*t2*abb&
      &1n10+t12*t3*abb1n23+t12*t4*abb1n22+t12*t5*abb1n19+t12*t6*abb1n9+t12*t7*ab&
      &b1n9+t12*t8*abb1n11+t12*t9*abb1n11+t12*abb1n21*(Q(1)*spvak4k1(1)-Q(2)*spv&
      &ak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4))+t2*t4*abb1n15+t2*t5*abb1n20+t&
      &4*t6*abb1n14+t4*t7*abb1n14+t1*t12*t3*abb1n24)
      numerator = cmplx(real(d1, ki), aimag(d1), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p8_udbar_neepssbar_globalsl1, only: epspow
      use p8_udbar_neepssbar_kinematics
      use p8_udbar_neepssbar_abbrevd1h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d1
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3+k2-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d1 = 0.0_ki
      t1 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t4 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t5 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t6 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t7 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t8 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t9 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t12 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      d1 = (t1*abb1n1+t10*abb1n6+t11*abb1n7+t2*abb1n12+t3*abb1n16+t4*abb1n17+t5*&
      &abb1n2+t6*abb1n5+t7*abb1n5+t8*abb1n6+t9*abb1n6+abb1n18*(Q(1)*spvak5k1(1)-&
      &Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))+t1*t11*abb1n8+t1*t12*&
      &abb1n13+t1*t2*abb1n4+t1*t6*abb1n3+t1*t7*abb1n3+t10*t12*abb1n11+t12*t2*abb&
      &1n10+t12*t3*abb1n23+t12*t4*abb1n22+t12*t5*abb1n19+t12*t6*abb1n9+t12*t7*ab&
      &b1n9+t12*t8*abb1n11+t12*t9*abb1n11+t12*abb1n21*(Q(1)*spvak4k1(1)-Q(2)*spv&
      &ak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4k1(4))+t2*t4*abb1n15+t2*t5*abb1n20+t&
      &4*t6*abb1n14+t4*t7*abb1n14+t1*t12*t3*abb1n24)

      numerator = cmplx(real(d1, ki), aimag(d1), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p8_udbar_neepssbar_d1h0l1
