module     p8_udbar_neepssbar_d31h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p8_udbar_neepssbar/helicity0/d31h0l1d.f90
   ! generator: haggies (1.1)
   use p8_udbar_neepssbar_config, only: ki
   use p8_udbar_neepssbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d31
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p8_udbar_neepssbar_globalsl1, only: epspow
      use p8_udbar_neepssbar_kinematics
      use p8_udbar_neepssbar_abbrevd31h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(deg.eq.0) then
         numerator = abb31n21
         return
      end if
      t1 = k1(iv1)
      t2 = k3(iv1)
      t3 = k4(iv1)
      t4 = spvak3k1(iv1)
      t5 = spvak3k4(iv1)
      t6 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (k2(iv1)*abb31n34+t1*abb31n36+t2*abb31n37+t3*abb31n37+t4*ab&
         &b31n39+t5*abb31n38+t6*abb31n35)
         return
      end if
      t7 = spvak2k5(iv2)
      t8 = spvak6k5(iv2)
      t9 = k1(iv2)
      t10 = spvak2k5(iv1)
      t11 = k3(iv2)
      t12 = k4(iv2)
      t13 = spvak3k1(iv2)
      t14 = spvak3k4(iv2)
      if(deg.eq.2) then
         numerator = (spvak2k1(iv1)*t8*abb31n33+spvak2k1(iv2)*t6*abb31n33+spvak2&
         &k4(iv1)*t8*abb31n28+spvak2k4(iv2)*t6*abb31n28+spvak6k1(iv1)*t7*abb31n3&
         &2+spvak6k1(iv2)*t10*abb31n32+spvak6k4(iv1)*t7*abb31n27+spvak6k4(iv2)*t&
         &10*abb31n27+t1*t7*abb31n26+t1*t8*abb31n31+t10*t11*abb31n25+t10*t12*abb&
         &31n25+t10*t13*abb31n22+t10*t14*abb31n24+t10*t9*abb31n26+t11*t6*abb31n3&
         &0+t12*t6*abb31n30+t13*t6*abb31n23+t14*t6*abb31n29+t2*t7*abb31n25+t2*t8&
         &*abb31n30+t3*t7*abb31n25+t3*t8*abb31n30+t4*t7*abb31n22+t4*t8*abb31n23+&
         &t5*t7*abb31n24+t5*t8*abb31n29+t6*t9*abb31n31)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d31:
   subroutine     reconstruct_d31(coeffs)
      use p8_udbar_neepssbar_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_31:
      coeffs%coeffs_31%c0 = derivative(czip)
      coeffs%coeffs_31%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_31%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_31%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_31%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_31%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_31%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_31%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_31%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_31%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_31%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_31%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_31%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_31%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_31%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_31:
   end subroutine reconstruct_d31
!---#] subroutine reconstruct_d31:
end module p8_udbar_neepssbar_d31h0l1d
