module     p8_udbar_neepssbar_d8h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p8_udbar_neepssbar/helicity0/d8h0l1d.f90
   ! generator: haggies (1.1)
   use p8_udbar_neepssbar_config, only: ki
   use p8_udbar_neepssbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d8
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p8_udbar_neepssbar_globalsl1, only: epspow
      use p8_udbar_neepssbar_kinematics
      use p8_udbar_neepssbar_abbrevd8h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      real(ki) :: t15
      real(ki) :: t16
      real(ki) :: t17
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t3 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t4 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t15 = dotproduct(k1, qshift)
      t16 = dotproduct(k5, qshift)
      t17 = dotproduct(k6, qshift)
      t5 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t1*abb8n13+abb8n19*dotproduct(qshift, qshift)+abb8n22*dotp&
         &roduct(k3, qshift)+abb8n22*dotproduct(k4, qshift)+abb8n23*(spvak2k4(1)&
         &*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-spvak2k4(4)*qsh&
         &ift(4))+t1*t15*abb8n17+t1*t16*abb8n18+t1*t17*abb8n18+t1*t2*abb8n14+t1*&
         &t3*abb8n15+t1*t4*abb8n16+t1*t5*abb8n20)
         return
      end if
      t6 = spvak3k4(iv1)
      t7 = k1(iv1)
      t8 = k5(iv1)
      t9 = k6(iv1)
      t10 = spvak2k1(iv1)
      t11 = spvak2k5(iv1)
      t12 = t6*abb8n18
      t13 = spvak6k1(iv1)
      t14 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (k3(iv1)*abb8n22+k4(iv1)*abb8n22+qshift(iv1)*abb8n21+spvak2&
         &k4(iv1)*abb8n23+t12*t16+t12*t17+t6*abb8n13+t1*t10*abb8n20+t1*t11*abb8n&
         &16+t1*t13*abb8n14+t1*t14*abb8n15+t1*t7*abb8n17+t1*t8*abb8n18+t1*t9*abb&
         &8n18+t15*t6*abb8n17+t2*t6*abb8n14+t3*t6*abb8n15+t4*t6*abb8n16+t5*t6*ab&
         &b8n20)
         return
      end if
      t1 = spvak3k4(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb8n19+k1(iv2)*t6*abb8n17+k5(iv2)*t6*&
         &abb8n18+k6(iv2)*t6*abb8n18+spvak2k1(iv2)*t6*abb8n20+spvak2k5(iv2)*t6*a&
         &bb8n16+spvak6k1(iv2)*t6*abb8n14+spvak6k5(iv2)*t6*abb8n15+t1*t10*abb8n2&
         &0+t1*t11*abb8n16+t1*t13*abb8n14+t1*t14*abb8n15+t1*t7*abb8n17+t1*t8*abb&
         &8n18+t1*t9*abb8n18)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d8:
   subroutine     reconstruct_d8(coeffs)
      use p8_udbar_neepssbar_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_8:
      coeffs%coeffs_8%c0 = derivative(czip)
      coeffs%coeffs_8%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_8%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_8%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_8%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_8%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_8%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_8%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_8%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_8%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_8%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_8%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_8%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_8%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_8%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_8:
   end subroutine reconstruct_d8
!---#] subroutine reconstruct_d8:
end module p8_udbar_neepssbar_d8h0l1d
