module     p8_udbar_neepssbar_d26h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p8_udbar_neepssbar/helicity1/d26h1l1d.f90
   ! generator: haggies (1.1)
   use p8_udbar_neepssbar_config, only: ki
   use p8_udbar_neepssbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d26
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p8_udbar_neepssbar_globalsl1, only: epspow
      use p8_udbar_neepssbar_kinematics
      use p8_udbar_neepssbar_abbrevd26h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb26n11+abb26n20*(spvak2k1(1)*qshift(1)-spvak2k1(2)*qshif&
         &t(2)-spvak2k1(3)*qshift(3)-spvak2k1(4)*qshift(4))+abb26n21*(spvak5k1(1&
         &)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-spvak5k1(4)*qs&
         &hift(4))+abb26n22*(spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k&
         &4(3)*qshift(3)-spvak2k4(4)*qshift(4))+abb26n23*(spvak5k4(1)*qshift(1)-&
         &spvak5k4(2)*qshift(2)-spvak5k4(3)*qshift(3)-spvak5k4(4)*qshift(4))+abb&
         &26n24*dotproduct(k3, qshift)+abb26n24*dotproduct(k4, qshift)+abb26n25*&
         &dotproduct(k1, qshift)+abb26n26*(spvak3k4(1)*qshift(1)-spvak3k4(2)*qsh&
         &ift(2)-spvak3k4(3)*qshift(3)-spvak3k4(4)*qshift(4))+abb26n27*(spvak3k1&
         &(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-spvak3k1(4)*&
         &qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb26n14+k3(iv1)*abb26n15+k4(iv1)*abb26n15+spvak2k&
         &1(iv1)*abb26n19+spvak2k4(iv1)*abb26n17+spvak3k1(iv1)*abb26n12+spvak3k4&
         &(iv1)*abb26n13+spvak5k1(iv1)*abb26n18+spvak5k4(iv1)*abb26n16)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d26:
   subroutine     reconstruct_d26(coeffs)
      use p8_udbar_neepssbar_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_26:
      coeffs%coeffs_26%c0 = derivative(czip)
      coeffs%coeffs_26%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_26%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_26%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_26%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_26:
   end subroutine reconstruct_d26
!---#] subroutine reconstruct_d26:
end module p8_udbar_neepssbar_d26h1l1d
