module     p9_udbar_neepgg_d45h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity0/d45h0l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d45
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd45h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      real(ki) :: t17
      real(ki) :: t18
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t2 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t17 = dotproduct(k6, qshift)
      t18 = dotproduct(k1, qshift)
      t3 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t4 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t5 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t6 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t7 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb45n21+t1*abb45n39+t17*abb45n42+t18*abb45n43+t2*abb45n40&
         &+t3*abb45n44+abb45n31*dotproduct(qshift, qshift)+abb45n41*dotproduct(k&
         &5, qshift)+abb45n45*(spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak&
         &2k5(3)*qshift(3)-spvak2k5(4)*qshift(4))+abb45n47*(spvak3k5(1)*qshift(1&
         &)-spvak3k5(2)*qshift(2)-spvak3k5(3)*qshift(3)-spvak3k5(4)*qshift(4))+t&
         &1*t3*abb45n29+t17*t3*abb45n24+t18*t3*abb45n25+t2*t3*abb45n23+t3*t4*abb&
         &45n22+t3*t5*abb45n26+t3*t6*abb45n27+t3*t7*abb45n28)
         return
      end if
      t8 = k1(iv1)
      t9 = k6(iv1)
      t10 = spvak5k1(iv1)
      t11 = spvak5k6(iv1)
      t12 = spvak6k5(iv1)
      t13 = spvak2k1(iv1)
      t14 = spvak2k6(iv1)
      t15 = spvak3k1(iv1)
      t16 = spvak3k6(iv1)
      if(deg.eq.1) then
         numerator = (k5(iv1)*abb45n36+qshift(iv1)*abb45n46+spvak2k5(iv1)*abb45n&
         &32+spvak3k5(iv1)*abb45n30+t10*abb45n38+t11*abb45n37+t12*abb45n33+t8*ab&
         &b45n34+t9*abb45n35+t1*t12*abb45n48+t10*t3*abb45n48+t11*t3*abb45n54+t12&
         &*t17*abb45n53+t12*t18*abb45n52+t12*t2*abb45n54+t12*t4*abb45n55+t12*t5*&
         &abb45n51+t12*t6*abb45n50+t12*t7*abb45n49+t13*t3*abb45n49+t14*t3*abb45n&
         &51+t15*t3*abb45n50+t16*t3*abb45n55+t3*t8*abb45n52+t3*t9*abb45n53)
         return
      end if
      t1 = spvak6k5(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb45n31+k1(iv2)*t12*abb45n25+k6(iv2)*&
         &t12*abb45n24+spvak2k1(iv2)*t12*abb45n28+spvak2k6(iv2)*t12*abb45n26+spv&
         &ak3k1(iv2)*t12*abb45n27+spvak3k6(iv2)*t12*abb45n22+spvak5k1(iv2)*t12*a&
         &bb45n29+spvak5k6(iv2)*t12*abb45n23+t1*t10*abb45n29+t1*t11*abb45n23+t1*&
         &t13*abb45n28+t1*t14*abb45n26+t1*t15*abb45n27+t1*t16*abb45n22+t1*t8*abb&
         &45n25+t1*t9*abb45n24)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d45:
   subroutine     reconstruct_d45(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_45:
      coeffs%coeffs_45%c0 = derivative(czip)
      coeffs%coeffs_45%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_45%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_45%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_45%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_45%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_45%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_45%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_45%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_45%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_45%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_45%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_45%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_45%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_45%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_45:
   end subroutine reconstruct_d45
!---#] subroutine reconstruct_d45:
end module p9_udbar_neepgg_d45h0l1d
