module     p9_udbar_neepgg_d65h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity0/d65h0l1.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p9_udbar_neepgg_groups, only: &
!           & sign => diagram65_sign, shift => diagram65_shift
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd65h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d65
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k6
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d65 = 0.0_ki
      t1 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t2 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t3 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t4 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t5 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      d65 = (abb65n6+t1*abb65n11+t2*abb65n8+abb65n10*(Q(1)*spvak2k5(1)-Q(2)*spva&
      &k2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+abb65n12*(Q(1)*Q(1)-Q(2)*Q(2)-&
      &Q(3)*Q(3)-Q(4)*Q(4))+abb65n13*(Q(1)*spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spv&
      &ak3k5(3)-Q(4)*spvak3k5(4))+abb65n16*(Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(&
      &3)*spvak6k1(3)-Q(4)*spvak6k1(4))+abb65n17*(Q(1)*spvak5k1(1)-Q(2)*spvak5k1&
      &(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))+abb65n2*(Q(1)*spvak6k4(1)-Q(2)*spv&
      &ak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4))+abb65n3*(Q(1)*spvak5k4(1)-Q(2&
      &)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4))+abb65n7*(Q(1)*spvak2k6(1&
      &)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+abb65n9*(Q(1)*spvak&
      &3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))+t1*t3*abb65n15&
      &+t1*t4*abb65n18+t1*t5*abb65n4+t2*t3*abb65n14+t2*t4*abb65n19+t2*t5*abb65n5&
      &)
      numerator = cmplx(real(d65, ki), aimag(d65), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd65h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d65
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k6
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d65 = 0.0_ki
      t1 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t2 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t3 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t4 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t5 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      d65 = (abb65n6+t1*abb65n11+t2*abb65n8+abb65n10*(Q(1)*spvak2k5(1)-Q(2)*spva&
      &k2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+abb65n12*(Q(1)*Q(1)-Q(2)*Q(2)-&
      &Q(3)*Q(3)-Q(4)*Q(4))+abb65n13*(Q(1)*spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spv&
      &ak3k5(3)-Q(4)*spvak3k5(4))+abb65n16*(Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(&
      &3)*spvak6k1(3)-Q(4)*spvak6k1(4))+abb65n17*(Q(1)*spvak5k1(1)-Q(2)*spvak5k1&
      &(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))+abb65n2*(Q(1)*spvak6k4(1)-Q(2)*spv&
      &ak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4))+abb65n3*(Q(1)*spvak5k4(1)-Q(2&
      &)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4))+abb65n7*(Q(1)*spvak2k6(1&
      &)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+abb65n9*(Q(1)*spvak&
      &3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))+t1*t3*abb65n15&
      &+t1*t4*abb65n18+t1*t5*abb65n4+t2*t3*abb65n14+t2*t4*abb65n19+t2*t5*abb65n5&
      &)

      numerator = cmplx(real(d65, ki), aimag(d65), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p9_udbar_neepgg_d65h0l1
