module     p9_udbar_neepgg_d97h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity0/d97h0l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d97
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd97h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      real(ki) :: t40
      real(ki) :: t41
      real(ki) :: t42
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = abb97n56
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      t3 = k3(iv1)
      t4 = k4(iv1)
      t5 = k5(iv1)
      t6 = k6(iv1)
      t7 = spvak2k5(iv1)
      t8 = spvak3k1(iv1)
      t9 = spvak3k4(iv1)
      t10 = spvak5k6(iv1)
      t11 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb97n95+t10*abb97n93+t11*abb97n90+t2*abb97n89+t3*abb97&
         &n94+t4*abb97n94+t5*abb97n88+t6*abb97n92+t7*abb97n97+t8*abb97n98+t9*abb&
         &97n96)
         return
      end if
      t40 = d(iv1,iv2)
      t12 = k2(iv2)
      t13 = k5(iv2)
      t14 = k6(iv2)
      t15 = spvak5k6(iv2)
      t16 = t1*t15
      t17 = spvak6k5(iv2)
      t18 = k1(iv2)
      t19 = t10*t18
      t20 = k3(iv2)
      t21 = k4(iv2)
      t22 = spvak3k1(iv2)
      t23 = spvak3k4(iv2)
      t24 = t15*t3
      t25 = t10*t20
      t26 = t15*t4
      t27 = t10*t21
      t28 = spvak2k5(iv2)
      t29 = t15*t8
      t30 = t10*t22
      t31 = t15*t9
      t32 = t10*t23
      if(deg.eq.2) then
         numerator = (t16*abb97n72+t19*abb97n72+t24*abb97n73+t25*abb97n73+t26*ab&
         &b97n73+t27*abb97n73+t29*abb97n67+t30*abb97n67+t31*abb97n70+t32*abb97n7&
         &0+(2.0_ki)*t40*abb97n83+spvak2k6(iv1)*t17*abb97n59+spvak2k6(iv2)*t11*a&
         &bb97n59+t1*t12*abb97n87+t1*t13*abb97n62+t1*t14*abb97n75+t1*t17*abb97n8&
         &1+t10*t12*abb97n78+t10*t13*abb97n76+t10*t14*abb97n77+t10*t17*abb97n64+&
         &t10*t28*abb97n60+t11*t12*abb97n82+t11*t13*abb97n66+t11*t14*abb97n65+t1&
         &1*t15*abb97n64+t11*t18*abb97n81+t11*t20*abb97n80+t11*t21*abb97n80+t11*&
         &t22*abb97n69+t11*t23*abb97n79+t12*t3*abb97n86+t12*t4*abb97n86+t12*t8*a&
         &bb97n84+t12*t9*abb97n85+t13*t3*abb97n63+t13*t4*abb97n63+t13*t7*abb97n5&
         &8+t13*t8*abb97n57+t13*t9*abb97n61+t14*t3*abb97n74+t14*t4*abb97n74+t14*&
         &t8*abb97n68+t14*t9*abb97n71+t15*t2*abb97n78+t15*t5*abb97n76+t15*t6*abb&
         &97n77+t15*t7*abb97n60+t17*t2*abb97n82+t17*t3*abb97n80+t17*t4*abb97n80+&
         &t17*t5*abb97n66+t17*t6*abb97n65+t17*t8*abb97n69+t17*t9*abb97n79+t18*t2&
         &*abb97n87+t18*t5*abb97n62+t18*t6*abb97n75+t2*t20*abb97n86+t2*t21*abb97&
         &n86+t2*t22*abb97n84+t2*t23*abb97n85+t20*t5*abb97n63+t20*t6*abb97n74+t2&
         &1*t5*abb97n63+t21*t6*abb97n74+t22*t5*abb97n57+t22*t6*abb97n68+t23*t5*a&
         &bb97n61+t23*t6*abb97n71+t28*t5*abb97n58)
         return
      end if
      t41 = d(iv2,iv3)
      t42 = d(iv1,iv3)
      t2 = k1(iv3)
      t5 = k3(iv3)
      t6 = k4(iv3)
      t12 = spvak3k1(iv3)
      t13 = spvak3k4(iv3)
      t14 = spvak5k6(iv3)
      t33 = spvak6k5(iv3)
      t34 = spvak2k1(iv1)
      t35 = spvak2k1(iv2)
      t36 = spvak2k1(iv3)
      t37 = spvak2k4(iv1)
      t38 = spvak2k4(iv2)
      t39 = spvak2k4(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k5(iv3)*t40*abb97n107+t1*t41*abb97n105+t10&
         &*t41*abb97n91+t11*t41*abb97n103+t12*t40*abb97n110+t13*t40*abb97n106+t1&
         &4*t40*abb97n91+t15*t42*abb97n91+t17*t42*abb97n103+t18*t42*abb97n105+t2&
         &*t40*abb97n105+t20*t42*abb97n104+t21*t42*abb97n104+t22*t42*abb97n110+t&
         &23*t42*abb97n106+t28*t42*abb97n107+t3*t41*abb97n104+t33*t40*abb97n103+&
         &t4*t41*abb97n104+t40*t5*abb97n104+t40*t6*abb97n104+t41*t7*abb97n107+t4&
         &1*t8*abb97n110+t41*t9*abb97n106)+t16*t33*abb97n100+t19*t33*abb97n100+t&
         &24*t33*abb97n101+t25*t33*abb97n101+t26*t33*abb97n101+t27*t33*abb97n101&
         &+t29*t33*abb97n109+t30*t33*abb97n109+t31*t33*abb97n102+t32*t33*abb97n1&
         &02+t1*t14*t17*abb97n100+t10*t12*t17*abb97n109+t10*t13*t17*abb97n102+t1&
         &0*t17*t2*abb97n100+t10*t17*t36*abb97n99+t10*t17*t39*abb97n108+t10*t17*&
         &t5*abb97n101+t10*t17*t6*abb97n101+t10*t33*t35*abb97n99+t10*t33*t38*abb&
         &97n108+t11*t12*t15*abb97n109+t11*t13*t15*abb97n102+t11*t14*t18*abb97n1&
         &00+t11*t14*t20*abb97n101+t11*t14*t21*abb97n101+t11*t14*t22*abb97n109+t&
         &11*t14*t23*abb97n102+t11*t14*t35*abb97n99+t11*t14*t38*abb97n108+t11*t1&
         &5*t2*abb97n100+t11*t15*t36*abb97n99+t11*t15*t39*abb97n108+t11*t15*t5*a&
         &bb97n101+t11*t15*t6*abb97n101+t14*t17*t3*abb97n101+t14*t17*t34*abb97n9&
         &9+t14*t17*t37*abb97n108+t14*t17*t4*abb97n101+t14*t17*t8*abb97n109+t14*&
         &t17*t9*abb97n102+t15*t33*t34*abb97n99+t15*t33*t37*abb97n108)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d97:
   subroutine     reconstruct_d97(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_97:
      coeffs%coeffs_97%c0 = derivative(czip)
      coeffs%coeffs_97%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_97%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_97%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_97%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_97%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_97%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_97%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_97%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_97%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_97%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_97%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_97%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_97%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_97%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_97%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_97%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_97%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_97%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_97%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_97%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_97%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_97%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_97%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_97%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_97%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_97%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_97%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_97%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_97%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_97%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_97%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_97%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_97%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_97%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_97:
   end subroutine reconstruct_d97
!---#] subroutine reconstruct_d97:
end module p9_udbar_neepgg_d97h0l1d
