module     p9_udbar_neepgg_d10h3l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity3/d10h3l1.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p9_udbar_neepgg_groups, only: &
!           & sign => diagram10_sign, shift => diagram10_shift
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd10h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d10
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(-Q_ext(4),   ki_sam), aimag(-Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3), ki_sam), aimag(-Q_ext(1:3)), ki)
      d10 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      d10 = (abb10n8+t1*abb10n17+t2*abb10n18+t3*abb10n19+t4*abb10n2+t5*abb10n20+&
      &abb10n10*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+abb10n11*(Q(1)*spv&
      &ak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4))+abb10n12*(Q(&
      &1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+abb10n&
      &13*(Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+abb10n14*(Q(1)*Q(1)-Q(2)&
      &*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+abb10n3*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3&
      &)*spvak2k4(3)-Q(4)*spvak2k4(4))+abb10n4*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2&
      &)-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4))+t1*t4*abb10n5+t2*t4*abb10n6+t3*t4*ab&
      &b10n7+t4*t5*abb10n9+t4*abb10n15*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*s&
      &pvak2k1(3)-Q(4)*spvak2k1(4))+t4*abb10n16*(Q(1)*spvak6k1(1)-Q(2)*spvak6k1(&
      &2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)))
      numerator = cmplx(real(d10, ki), aimag(d10), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd10h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d10
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(-Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d10 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      d10 = (abb10n8+t1*abb10n17+t2*abb10n18+t3*abb10n19+t4*abb10n2+t5*abb10n20+&
      &abb10n10*(Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+abb10n11*(Q(1)*spv&
      &ak6k2(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4))+abb10n12*(Q(&
      &1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+abb10n&
      &13*(Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))+abb10n14*(Q(1)*Q(1)-Q(2)&
      &*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+abb10n3*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3&
      &)*spvak2k4(3)-Q(4)*spvak2k4(4))+abb10n4*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2&
      &)-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4))+t1*t4*abb10n5+t2*t4*abb10n6+t3*t4*ab&
      &b10n7+t4*t5*abb10n9+t4*abb10n15*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*s&
      &pvak2k1(3)-Q(4)*spvak2k1(4))+t4*abb10n16*(Q(1)*spvak6k1(1)-Q(2)*spvak6k1(&
      &2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)))

      numerator = cmplx(real(d10, ki), aimag(d10), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p9_udbar_neepgg_d10h3l1
