module     p9_udbar_neepgg_d17h3l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity3/d17h3l1.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p9_udbar_neepgg_groups, only: &
!           & sign => diagram17_sign, shift => diagram17_shift
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd17h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d17
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k2
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d17 = 0.0_ki
      t1 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t2 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t3 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t4 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t5 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t6 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t7 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t10 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t11 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      d17 = (abb17n1+t1*abb17n16+t10*abb17n6+t2*abb17n17+t2*t2*abb17n29+t3*abb17&
      &n18+t3*t3*abb17n29+t4*abb17n2+t5*abb17n20+t6*abb17n21+t7*abb17n23+t8*abb1&
      &7n4+t9*abb17n5+t1*t2*abb17n34+t1*t3*abb17n36+t1*t5*abb17n35+t1*t6*abb17n3&
      &7+t1*t8*abb17n34+t1*t9*abb17n15+t10*t2*abb17n9+t10*t3*abb17n11+t10*t5*abb&
      &17n10+t10*t6*abb17n22+t10*t8*abb17n9+t11*t9*abb17n3+t2*t3*abb17n25+t2*t5*&
      &abb17n27+t2*t6*abb17n30+t2*t7*abb17n41+t2*t8*abb17n29+t2*t9*abb17n14+t3*t&
      &5*abb17n28+t3*t6*abb17n31+t3*t7*abb17n39+t3*t8*abb17n26+t3*t9*abb17n13+t4&
      &*t6*abb17n19+t5*t7*abb17n40+t5*t9*abb17n7+t6*t7*abb17n42+t6*t9*abb17n8+t7&
      &*t8*abb17n41+t7*t9*abb17n12+t1*t6*t9*abb17n38+t11*t6*t9*abb17n24+t2*t6*t9&
      &*abb17n33+t3*t6*t9*abb17n32+t6*t7*t9*abb17n43)
      numerator = cmplx(real(d17, ki), aimag(d17), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd17h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d17
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k2
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d17 = 0.0_ki
      t1 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t2 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t3 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t4 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t5 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t6 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t7 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t8 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t9 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t10 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t11 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      d17 = (abb17n1+t1*abb17n16+t10*abb17n6+t2*abb17n17+t2*t2*abb17n29+t3*abb17&
      &n18+t3*t3*abb17n29+t4*abb17n2+t5*abb17n20+t6*abb17n21+t7*abb17n23+t8*abb1&
      &7n4+t9*abb17n5+t1*t2*abb17n34+t1*t3*abb17n36+t1*t5*abb17n35+t1*t6*abb17n3&
      &7+t1*t8*abb17n34+t1*t9*abb17n15+t10*t2*abb17n9+t10*t3*abb17n11+t10*t5*abb&
      &17n10+t10*t6*abb17n22+t10*t8*abb17n9+t11*t9*abb17n3+t2*t3*abb17n25+t2*t5*&
      &abb17n27+t2*t6*abb17n30+t2*t7*abb17n41+t2*t8*abb17n29+t2*t9*abb17n14+t3*t&
      &5*abb17n28+t3*t6*abb17n31+t3*t7*abb17n39+t3*t8*abb17n26+t3*t9*abb17n13+t4&
      &*t6*abb17n19+t5*t7*abb17n40+t5*t9*abb17n7+t6*t7*abb17n42+t6*t9*abb17n8+t7&
      &*t8*abb17n41+t7*t9*abb17n12+t1*t6*t9*abb17n38+t11*t6*t9*abb17n24+t2*t6*t9&
      &*abb17n33+t3*t6*t9*abb17n32+t6*t7*t9*abb17n43)

      numerator = cmplx(real(d17, ki), aimag(d17), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p9_udbar_neepgg_d17h3l1
