module     p9_udbar_neepgg_d24h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity3/d24h3l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d24
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd24h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      real(ki) :: t32
      real(ki) :: t33
      real(ki) :: t34
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = abb24n47
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      t3 = k5(iv1)
      t4 = k6(iv1)
      t5 = spvak3k4(iv1)
      t6 = spvak5k6(iv1)
      t7 = spvak6k1(iv1)
      t8 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb24n81+t2*abb24n74+t3*abb24n76+t4*abb24n82+t5*abb24n7&
         &3+t6*abb24n78+t7*abb24n79+t8*abb24n87)
         return
      end if
      t32 = d(iv1,iv2)
      t9 = k1(iv2)
      t10 = k6(iv2)
      t11 = k2(iv2)
      t12 = k5(iv2)
      t13 = spvak3k4(iv2)
      t14 = t1*t13
      t15 = spvak5k6(iv2)
      t16 = spvak6k1(iv2)
      t17 = spvak6k5(iv2)
      t18 = t5*t9
      t19 = t13*t4
      t20 = t10*t5
      t21 = t15*t5
      t22 = t13*t6
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t32*abb24n64+t1*t9*abb24n57+t10*t4*abb24n57)+t14&
         &*abb24n71+t18*abb24n71+t19*abb24n72+t20*abb24n72+t21*abb24n63+t22*abb2&
         &4n63+spvak2k4(iv1)*t15*abb24n62+spvak2k4(iv2)*t6*abb24n62+t1*t10*abb24&
         &n59+t1*t11*abb24n60+t1*t12*abb24n58+t1*t15*abb24n55+t1*t16*abb24n50+t1&
         &*t17*abb24n52+t10*t2*abb24n61+t10*t3*abb24n57+t10*t6*abb24n56+t10*t7*a&
         &bb24n49+t10*t8*abb24n53+t11*t4*abb24n61+t11*t6*abb24n65+t11*t7*abb24n6&
         &8+t11*t8*abb24n54+t12*t4*abb24n57+t12*t5*abb24n70+t12*t6*abb24n66+t12*&
         &t7*abb24n49+t12*t8*abb24n53+t13*t3*abb24n70+t13*t7*abb24n67+t13*t8*abb&
         &24n69+t15*t2*abb24n65+t15*t3*abb24n66+t15*t4*abb24n56+t15*t7*abb24n48+&
         &t15*t8*abb24n51+t16*t2*abb24n68+t16*t3*abb24n49+t16*t4*abb24n49+t16*t5&
         &*abb24n67+t16*t6*abb24n48+t17*t2*abb24n54+t17*t3*abb24n53+t17*t4*abb24&
         &n53+t17*t5*abb24n69+t17*t6*abb24n51+t2*t9*abb24n60+t3*t9*abb24n58+t4*t&
         &9*abb24n59+t6*t9*abb24n55+t7*t9*abb24n50+t8*t9*abb24n52)
         return
      end if
      t33 = d(iv2,iv3)
      t34 = d(iv1,iv3)
      t2 = k1(iv3)
      t3 = k6(iv3)
      t11 = spvak3k4(iv3)
      t12 = spvak5k6(iv3)
      t23 = spvak6k1(iv3)
      t24 = spvak6k5(iv3)
      t25 = spvak2k1(iv1)
      t26 = spvak2k1(iv2)
      t27 = spvak2k1(iv3)
      t28 = t12*t5
      t29 = t12*t13
      t30 = t11*t6
      t31 = t11*t15
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t1*t33*abb24n83+t10*t34*abb24n84+t11*t32*abb24n7&
         &5+t12*t32*abb24n77+t13*t34*abb24n75+t15*t34*abb24n77+t16*t34*abb24n90+&
         &t17*t34*abb24n88+t2*t32*abb24n83+t23*t32*abb24n90+t24*t32*abb24n88+t3*&
         &t32*abb24n84+t33*t4*abb24n84+t33*t5*abb24n75+t33*t6*abb24n77+t33*t7*ab&
         &b24n90+t33*t8*abb24n88+t34*t9*abb24n83)+t12*t14*abb24n86+t12*t18*abb24&
         &n86+t12*t19*abb24n85+t12*t20*abb24n85+t16*t28*abb24n91+t16*t30*abb24n9&
         &1+t17*t28*abb24n89+t17*t30*abb24n89+t21*t23*abb24n91+t21*t24*abb24n89+&
         &t22*t23*abb24n91+t22*t24*abb24n89+t29*t7*abb24n91+t29*t8*abb24n89+t31*&
         &t7*abb24n91+t31*t8*abb24n89+t1*t11*t15*abb24n86+t10*t11*t6*abb24n85+t1&
         &1*t15*t25*abb24n80+t11*t15*t4*abb24n85+t11*t26*t6*abb24n80+t11*t6*t9*a&
         &bb24n86+t12*t13*t25*abb24n80+t12*t26*t5*abb24n80+t13*t2*t6*abb24n86+t1&
         &3*t27*t6*abb24n80+t13*t3*t6*abb24n85+t15*t2*t5*abb24n86+t15*t27*t5*abb&
         &24n80+t15*t3*t5*abb24n85)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d24:
   subroutine     reconstruct_d24(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_24:
      coeffs%coeffs_24%c0 = derivative(czip)
      coeffs%coeffs_24%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_24%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_24%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_24%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_24%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_24%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_24%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_24%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_24%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_24%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_24%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_24%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_24%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_24%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_24%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_24%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_24%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_24%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_24%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_24%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_24%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_24%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_24%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_24%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_24%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_24%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_24%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_24%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_24%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_24%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_24%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_24%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_24%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_24%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_24:
   end subroutine reconstruct_d24
!---#] subroutine reconstruct_d24:
end module p9_udbar_neepgg_d24h3l1d
