module     p9_udbar_neepgg_d81h3l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity3/d81h3l1.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p9_udbar_neepgg_groups, only: &
!           & sign => diagram81_sign, shift => diagram81_shift
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd81h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d81

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k6-k5
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d81 = 0.0_ki
      d81 = (abb81n1+abb81n10*(Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3&
      &)-Q(4)*spvak3k4(4))+abb81n11*(Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spva&
      &k3k1(3)-Q(4)*spvak3k1(4))+abb81n2*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)&
      &*spvak2k1(3)-Q(4)*spvak2k1(4))+abb81n3*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)&
      &-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+abb81n4*(Q(1)*spvak6k1(1)-Q(2)*spvak6&
      &k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))+abb81n5*(Q(1)*spvak5k1(1)-Q(2)*s&
      &pvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))+abb81n6*(Q(1)*spvak6k4(1)-Q&
      &(2)*spvak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4))+abb81n7*(Q(1)*spvak5k4&
      &(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4))+abb81n8*(Q(1)*k1(&
      &1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))+abb81n9*(Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*&
      &k3(3)-Q(4)*k3(4))+abb81n9*(Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4)))
      numerator = cmplx(real(d81, ki), aimag(d81), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd81h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d81

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k6-k5
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d81 = 0.0_ki
      d81 = (abb81n1+abb81n10*(Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3&
      &)-Q(4)*spvak3k4(4))+abb81n11*(Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spva&
      &k3k1(3)-Q(4)*spvak3k1(4))+abb81n2*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)&
      &*spvak2k1(3)-Q(4)*spvak2k1(4))+abb81n3*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)&
      &-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+abb81n4*(Q(1)*spvak6k1(1)-Q(2)*spvak6&
      &k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))+abb81n5*(Q(1)*spvak5k1(1)-Q(2)*s&
      &pvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))+abb81n6*(Q(1)*spvak6k4(1)-Q&
      &(2)*spvak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4))+abb81n7*(Q(1)*spvak5k4&
      &(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4))+abb81n8*(Q(1)*k1(&
      &1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))+abb81n9*(Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*&
      &k3(3)-Q(4)*k3(4))+abb81n9*(Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4)))

      numerator = cmplx(real(d81, ki), aimag(d81), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p9_udbar_neepgg_d81h3l1
