module     p9_udbar_neepgg_golem95h3
   use precision_golem, only: ki_gol => ki
   use p9_udbar_neepgg_config, only: ki
   implicit none
   private
   interface reconstruct_group
      module procedure reconstruct_group0
      module procedure reconstruct_group1
      module procedure reconstruct_group2
      module procedure reconstruct_group3
      module procedure reconstruct_group4
      module procedure reconstruct_group5
      module procedure reconstruct_group6
      module procedure reconstruct_group7
      module procedure reconstruct_group8
      module procedure reconstruct_group9
      module procedure reconstruct_group10
      module procedure reconstruct_group11
      module procedure reconstruct_group12
   end interface

   public :: reconstruct_group
contains
!---#[ subroutine reconstruct_group0:
subroutine     reconstruct_group0(coeffs)
   use tens_rec
   use p9_udbar_neepgg_config
   use p9_udbar_neepgg_groups, only: tensrec_info_group0
   use p9_udbar_neepgg_d65h3l1, only: numerator_d65 => numerator_golem95
   use p9_udbar_neepgg_d65h3l1d, only: reconstruct_d65
   use p9_udbar_neepgg_d115h3l1, only: numerator_d115 => numerator_golem95
   use p9_udbar_neepgg_d115h3l1d, only: reconstruct_d115
   implicit none
   type(tensrec_info_group0), intent(out) :: coeffs
   !------#[ Diagram 65:
      if (tens_rec_by_derivatives) then
         call reconstruct_d65(coeffs)
      else
         call reconstruct2(numerator_d65, coeffs%coeffs_65)
      end if
   !------#] Diagram 65:
   !------#[ Diagram 115:
      if (tens_rec_by_derivatives) then
         call reconstruct_d115(coeffs)
      else
         call reconstruct3(numerator_d115, coeffs%coeffs_115)
      end if
   !------#] Diagram 115:
end subroutine reconstruct_group0
!---#] subroutine reconstruct_group0:
!---#[ subroutine reconstruct_group1:
subroutine     reconstruct_group1(coeffs)
   use tens_rec
   use p9_udbar_neepgg_config
   use p9_udbar_neepgg_groups, only: tensrec_info_group1
   use p9_udbar_neepgg_d19h3l1, only: numerator_d19 => numerator_golem95
   use p9_udbar_neepgg_d19h3l1d, only: reconstruct_d19
   use p9_udbar_neepgg_d92h3l1, only: numerator_d92 => numerator_golem95
   use p9_udbar_neepgg_d92h3l1d, only: reconstruct_d92
   implicit none
   type(tensrec_info_group1), intent(out) :: coeffs
   !------#[ Diagram 19:
      if (tens_rec_by_derivatives) then
         call reconstruct_d19(coeffs)
      else
         call reconstruct3(numerator_d19, coeffs%coeffs_19)
      end if
   !------#] Diagram 19:
   !------#[ Diagram 92:
      if (tens_rec_by_derivatives) then
         call reconstruct_d92(coeffs)
      else
         call reconstruct4(numerator_d92, coeffs%coeffs_92)
      end if
   !------#] Diagram 92:
end subroutine reconstruct_group1
!---#] subroutine reconstruct_group1:
!---#[ subroutine reconstruct_group2:
subroutine     reconstruct_group2(coeffs)
   use tens_rec
   use p9_udbar_neepgg_config
   use p9_udbar_neepgg_groups, only: tensrec_info_group2
   use p9_udbar_neepgg_d10h3l1, only: numerator_d10 => numerator_golem95
   use p9_udbar_neepgg_d10h3l1d, only: reconstruct_d10
   use p9_udbar_neepgg_d12h3l1, only: numerator_d12 => numerator_golem95
   use p9_udbar_neepgg_d12h3l1d, only: reconstruct_d12
   use p9_udbar_neepgg_d21h3l1, only: numerator_d21 => numerator_golem95
   use p9_udbar_neepgg_d21h3l1d, only: reconstruct_d21
   use p9_udbar_neepgg_d28h3l1, only: numerator_d28 => numerator_golem95
   use p9_udbar_neepgg_d28h3l1d, only: reconstruct_d28
   use p9_udbar_neepgg_d31h3l1, only: numerator_d31 => numerator_golem95
   use p9_udbar_neepgg_d31h3l1d, only: reconstruct_d31
   use p9_udbar_neepgg_d49h3l1, only: numerator_d49 => numerator_golem95
   use p9_udbar_neepgg_d49h3l1d, only: reconstruct_d49
   use p9_udbar_neepgg_d90h3l1, only: numerator_d90 => numerator_golem95
   use p9_udbar_neepgg_d90h3l1d, only: reconstruct_d90
   use p9_udbar_neepgg_d95h3l1, only: numerator_d95 => numerator_golem95
   use p9_udbar_neepgg_d95h3l1d, only: reconstruct_d95
   implicit none
   type(tensrec_info_group2), intent(out) :: coeffs
   !------#[ Diagram 10:
      if (tens_rec_by_derivatives) then
         call reconstruct_d10(coeffs)
      else
         call reconstruct2(numerator_d10, coeffs%coeffs_10)
      end if
   !------#] Diagram 10:
   !------#[ Diagram 12:
      if (tens_rec_by_derivatives) then
         call reconstruct_d12(coeffs)
      else
         call reconstruct1(numerator_d12, coeffs%coeffs_12)
      end if
   !------#] Diagram 12:
   !------#[ Diagram 21:
      if (tens_rec_by_derivatives) then
         call reconstruct_d21(coeffs)
      else
         call reconstruct3(numerator_d21, coeffs%coeffs_21)
      end if
   !------#] Diagram 21:
   !------#[ Diagram 28:
      if (tens_rec_by_derivatives) then
         call reconstruct_d28(coeffs)
      else
         call reconstruct3(numerator_d28, coeffs%coeffs_28)
      end if
   !------#] Diagram 28:
   !------#[ Diagram 31:
      if (tens_rec_by_derivatives) then
         call reconstruct_d31(coeffs)
      else
         call reconstruct2(numerator_d31, coeffs%coeffs_31)
      end if
   !------#] Diagram 31:
   !------#[ Diagram 49:
      if (tens_rec_by_derivatives) then
         call reconstruct_d49(coeffs)
      else
         call reconstruct2(numerator_d49, coeffs%coeffs_49)
      end if
   !------#] Diagram 49:
   !------#[ Diagram 90:
      if (tens_rec_by_derivatives) then
         call reconstruct_d90(coeffs)
      else
         call reconstruct4(numerator_d90, coeffs%coeffs_90)
      end if
   !------#] Diagram 90:
   !------#[ Diagram 95:
      if (tens_rec_by_derivatives) then
         call reconstruct_d95(coeffs)
      else
         call reconstruct3(numerator_d95, coeffs%coeffs_95)
      end if
   !------#] Diagram 95:
end subroutine reconstruct_group2
!---#] subroutine reconstruct_group2:
!---#[ subroutine reconstruct_group3:
subroutine     reconstruct_group3(coeffs)
   use tens_rec
   use p9_udbar_neepgg_config
   use p9_udbar_neepgg_groups, only: tensrec_info_group3
   use p9_udbar_neepgg_d1h3l1, only: numerator_d1 => numerator_golem95
   use p9_udbar_neepgg_d1h3l1d, only: reconstruct_d1
   use p9_udbar_neepgg_d3h3l1, only: numerator_d3 => numerator_golem95
   use p9_udbar_neepgg_d3h3l1d, only: reconstruct_d3
   use p9_udbar_neepgg_d11h3l1, only: numerator_d11 => numerator_golem95
   use p9_udbar_neepgg_d11h3l1d, only: reconstruct_d11
   use p9_udbar_neepgg_d14h3l1, only: numerator_d14 => numerator_golem95
   use p9_udbar_neepgg_d14h3l1d, only: reconstruct_d14
   use p9_udbar_neepgg_d20h3l1, only: numerator_d20 => numerator_golem95
   use p9_udbar_neepgg_d20h3l1d, only: reconstruct_d20
   use p9_udbar_neepgg_d24h3l1, only: numerator_d24 => numerator_golem95
   use p9_udbar_neepgg_d24h3l1d, only: reconstruct_d24
   use p9_udbar_neepgg_d26h3l1, only: numerator_d26 => numerator_golem95
   use p9_udbar_neepgg_d26h3l1d, only: reconstruct_d26
   use p9_udbar_neepgg_d35h3l1, only: numerator_d35 => numerator_golem95
   use p9_udbar_neepgg_d35h3l1d, only: reconstruct_d35
   use p9_udbar_neepgg_d39h3l1, only: numerator_d39 => numerator_golem95
   use p9_udbar_neepgg_d39h3l1d, only: reconstruct_d39
   use p9_udbar_neepgg_d45h3l1, only: numerator_d45 => numerator_golem95
   use p9_udbar_neepgg_d45h3l1d, only: reconstruct_d45
   use p9_udbar_neepgg_d53h3l1, only: numerator_d53 => numerator_golem95
   use p9_udbar_neepgg_d53h3l1d, only: reconstruct_d53
   use p9_udbar_neepgg_d77h3l1, only: numerator_d77 => numerator_golem95
   use p9_udbar_neepgg_d77h3l1d, only: reconstruct_d77
   use p9_udbar_neepgg_d82h3l1, only: numerator_d82 => numerator_golem95
   use p9_udbar_neepgg_d82h3l1d, only: reconstruct_d82
   use p9_udbar_neepgg_d94h3l1, only: numerator_d94 => numerator_golem95
   use p9_udbar_neepgg_d94h3l1d, only: reconstruct_d94
   use p9_udbar_neepgg_d105h3l1, only: numerator_d105 => numerator_golem95
   use p9_udbar_neepgg_d105h3l1d, only: reconstruct_d105
   implicit none
   type(tensrec_info_group3), intent(out) :: coeffs
   !------#[ Diagram 1:
      if (tens_rec_by_derivatives) then
         call reconstruct_d1(coeffs)
      else
         call reconstruct2(numerator_d1, coeffs%coeffs_1)
      end if
   !------#] Diagram 1:
   !------#[ Diagram 3:
      if (tens_rec_by_derivatives) then
         call reconstruct_d3(coeffs)
      else
         call reconstruct1(numerator_d3, coeffs%coeffs_3)
      end if
   !------#] Diagram 3:
   !------#[ Diagram 11:
      if (tens_rec_by_derivatives) then
         call reconstruct_d11(coeffs)
      else
         call reconstruct2(numerator_d11, coeffs%coeffs_11)
      end if
   !------#] Diagram 11:
   !------#[ Diagram 14:
      if (tens_rec_by_derivatives) then
         call reconstruct_d14(coeffs)
      else
         call reconstruct1(numerator_d14, coeffs%coeffs_14)
      end if
   !------#] Diagram 14:
   !------#[ Diagram 20:
      if (tens_rec_by_derivatives) then
         call reconstruct_d20(coeffs)
      else
         call reconstruct3(numerator_d20, coeffs%coeffs_20)
      end if
   !------#] Diagram 20:
   !------#[ Diagram 24:
      if (tens_rec_by_derivatives) then
         call reconstruct_d24(coeffs)
      else
         call reconstruct3(numerator_d24, coeffs%coeffs_24)
      end if
   !------#] Diagram 24:
   !------#[ Diagram 26:
      if (tens_rec_by_derivatives) then
         call reconstruct_d26(coeffs)
      else
         call reconstruct3(numerator_d26, coeffs%coeffs_26)
      end if
   !------#] Diagram 26:
   !------#[ Diagram 35:
      if (tens_rec_by_derivatives) then
         call reconstruct_d35(coeffs)
      else
         call reconstruct2(numerator_d35, coeffs%coeffs_35)
      end if
   !------#] Diagram 35:
   !------#[ Diagram 39:
      if (tens_rec_by_derivatives) then
         call reconstruct_d39(coeffs)
      else
         call reconstruct2(numerator_d39, coeffs%coeffs_39)
      end if
   !------#] Diagram 39:
   !------#[ Diagram 45:
      if (tens_rec_by_derivatives) then
         call reconstruct_d45(coeffs)
      else
         call reconstruct2(numerator_d45, coeffs%coeffs_45)
      end if
   !------#] Diagram 45:
   !------#[ Diagram 53:
      if (tens_rec_by_derivatives) then
         call reconstruct_d53(coeffs)
      else
         call reconstruct2(numerator_d53, coeffs%coeffs_53)
      end if
   !------#] Diagram 53:
   !------#[ Diagram 77:
      if (tens_rec_by_derivatives) then
         call reconstruct_d77(coeffs)
      else
         call reconstruct1(numerator_d77, coeffs%coeffs_77)
      end if
   !------#] Diagram 77:
   !------#[ Diagram 82:
      if (tens_rec_by_derivatives) then
         call reconstruct_d82(coeffs)
      else
         call reconstruct1(numerator_d82, coeffs%coeffs_82)
      end if
   !------#] Diagram 82:
   !------#[ Diagram 94:
      if (tens_rec_by_derivatives) then
         call reconstruct_d94(coeffs)
      else
         call reconstruct4(numerator_d94, coeffs%coeffs_94)
      end if
   !------#] Diagram 94:
   !------#[ Diagram 105:
      if (tens_rec_by_derivatives) then
         call reconstruct_d105(coeffs)
      else
         call reconstruct3(numerator_d105, coeffs%coeffs_105)
      end if
   !------#] Diagram 105:
end subroutine reconstruct_group3
!---#] subroutine reconstruct_group3:
!---#[ subroutine reconstruct_group4:
subroutine     reconstruct_group4(coeffs)
   use tens_rec
   use p9_udbar_neepgg_config
   use p9_udbar_neepgg_groups, only: tensrec_info_group4
   use p9_udbar_neepgg_d2h3l1, only: numerator_d2 => numerator_golem95
   use p9_udbar_neepgg_d2h3l1d, only: reconstruct_d2
   use p9_udbar_neepgg_d4h3l1, only: numerator_d4 => numerator_golem95
   use p9_udbar_neepgg_d4h3l1d, only: reconstruct_d4
   use p9_udbar_neepgg_d6h3l1, only: numerator_d6 => numerator_golem95
   use p9_udbar_neepgg_d6h3l1d, only: reconstruct_d6
   use p9_udbar_neepgg_d7h3l1, only: numerator_d7 => numerator_golem95
   use p9_udbar_neepgg_d7h3l1d, only: reconstruct_d7
   use p9_udbar_neepgg_d13h3l1, only: numerator_d13 => numerator_golem95
   use p9_udbar_neepgg_d13h3l1d, only: reconstruct_d13
   use p9_udbar_neepgg_d18h3l1, only: numerator_d18 => numerator_golem95
   use p9_udbar_neepgg_d18h3l1d, only: reconstruct_d18
   use p9_udbar_neepgg_d29h3l1, only: numerator_d29 => numerator_golem95
   use p9_udbar_neepgg_d29h3l1d, only: reconstruct_d29
   use p9_udbar_neepgg_d33h3l1, only: numerator_d33 => numerator_golem95
   use p9_udbar_neepgg_d33h3l1d, only: reconstruct_d33
   use p9_udbar_neepgg_d41h3l1, only: numerator_d41 => numerator_golem95
   use p9_udbar_neepgg_d41h3l1d, only: reconstruct_d41
   use p9_udbar_neepgg_d47h3l1, only: numerator_d47 => numerator_golem95
   use p9_udbar_neepgg_d47h3l1d, only: reconstruct_d47
   use p9_udbar_neepgg_d51h3l1, only: numerator_d51 => numerator_golem95
   use p9_udbar_neepgg_d51h3l1d, only: reconstruct_d51
   use p9_udbar_neepgg_d61h3l1, only: numerator_d61 => numerator_golem95
   use p9_udbar_neepgg_d61h3l1d, only: reconstruct_d61
   use p9_udbar_neepgg_d79h3l1, only: numerator_d79 => numerator_golem95
   use p9_udbar_neepgg_d79h3l1d, only: reconstruct_d79
   use p9_udbar_neepgg_d81h3l1, only: numerator_d81 => numerator_golem95
   use p9_udbar_neepgg_d81h3l1d, only: reconstruct_d81
   use p9_udbar_neepgg_d89h3l1, only: numerator_d89 => numerator_golem95
   use p9_udbar_neepgg_d89h3l1d, only: reconstruct_d89
   use p9_udbar_neepgg_d97h3l1, only: numerator_d97 => numerator_golem95
   use p9_udbar_neepgg_d97h3l1d, only: reconstruct_d97
   use p9_udbar_neepgg_d107h3l1, only: numerator_d107 => numerator_golem95
   use p9_udbar_neepgg_d107h3l1d, only: reconstruct_d107
   implicit none
   type(tensrec_info_group4), intent(out) :: coeffs
   !------#[ Diagram 2:
      if (tens_rec_by_derivatives) then
         call reconstruct_d2(coeffs)
      else
         call reconstruct1(numerator_d2, coeffs%coeffs_2)
      end if
   !------#] Diagram 2:
   !------#[ Diagram 4:
      if (tens_rec_by_derivatives) then
         call reconstruct_d4(coeffs)
      else
         call reconstruct1(numerator_d4, coeffs%coeffs_4)
      end if
   !------#] Diagram 4:
   !------#[ Diagram 6:
      if (tens_rec_by_derivatives) then
         call reconstruct_d6(coeffs)
      else
         call reconstruct1(numerator_d6, coeffs%coeffs_6)
      end if
   !------#] Diagram 6:
   !------#[ Diagram 7:
      if (tens_rec_by_derivatives) then
         call reconstruct_d7(coeffs)
      else
         call reconstruct1(numerator_d7, coeffs%coeffs_7)
      end if
   !------#] Diagram 7:
   !------#[ Diagram 13:
      if (tens_rec_by_derivatives) then
         call reconstruct_d13(coeffs)
      else
         call reconstruct1(numerator_d13, coeffs%coeffs_13)
      end if
   !------#] Diagram 13:
   !------#[ Diagram 18:
      if (tens_rec_by_derivatives) then
         call reconstruct_d18(coeffs)
      else
         call reconstruct3(numerator_d18, coeffs%coeffs_18)
      end if
   !------#] Diagram 18:
   !------#[ Diagram 29:
      if (tens_rec_by_derivatives) then
         call reconstruct_d29(coeffs)
      else
         call reconstruct3(numerator_d29, coeffs%coeffs_29)
      end if
   !------#] Diagram 29:
   !------#[ Diagram 33:
      if (tens_rec_by_derivatives) then
         call reconstruct_d33(coeffs)
      else
         call reconstruct2(numerator_d33, coeffs%coeffs_33)
      end if
   !------#] Diagram 33:
   !------#[ Diagram 41:
      if (tens_rec_by_derivatives) then
         call reconstruct_d41(coeffs)
      else
         call reconstruct2(numerator_d41, coeffs%coeffs_41)
      end if
   !------#] Diagram 41:
   !------#[ Diagram 47:
      if (tens_rec_by_derivatives) then
         call reconstruct_d47(coeffs)
      else
         call reconstruct2(numerator_d47, coeffs%coeffs_47)
      end if
   !------#] Diagram 47:
   !------#[ Diagram 51:
      if (tens_rec_by_derivatives) then
         call reconstruct_d51(coeffs)
      else
         call reconstruct2(numerator_d51, coeffs%coeffs_51)
      end if
   !------#] Diagram 51:
   !------#[ Diagram 61:
      if (tens_rec_by_derivatives) then
         call reconstruct_d61(coeffs)
      else
         call reconstruct2(numerator_d61, coeffs%coeffs_61)
      end if
   !------#] Diagram 61:
   !------#[ Diagram 79:
      if (tens_rec_by_derivatives) then
         call reconstruct_d79(coeffs)
      else
         call reconstruct1(numerator_d79, coeffs%coeffs_79)
      end if
   !------#] Diagram 79:
   !------#[ Diagram 81:
      if (tens_rec_by_derivatives) then
         call reconstruct_d81(coeffs)
      else
         call reconstruct1(numerator_d81, coeffs%coeffs_81)
      end if
   !------#] Diagram 81:
   !------#[ Diagram 89:
      if (tens_rec_by_derivatives) then
         call reconstruct_d89(coeffs)
      else
         call reconstruct4(numerator_d89, coeffs%coeffs_89)
      end if
   !------#] Diagram 89:
   !------#[ Diagram 97:
      if (tens_rec_by_derivatives) then
         call reconstruct_d97(coeffs)
      else
         call reconstruct3(numerator_d97, coeffs%coeffs_97)
      end if
   !------#] Diagram 97:
   !------#[ Diagram 107:
      if (tens_rec_by_derivatives) then
         call reconstruct_d107(coeffs)
      else
         call reconstruct3(numerator_d107, coeffs%coeffs_107)
      end if
   !------#] Diagram 107:
end subroutine reconstruct_group4
!---#] subroutine reconstruct_group4:
!---#[ subroutine reconstruct_group5:
subroutine     reconstruct_group5(coeffs)
   use tens_rec
   use p9_udbar_neepgg_config
   use p9_udbar_neepgg_groups, only: tensrec_info_group5
   use p9_udbar_neepgg_d15h3l1, only: numerator_d15 => numerator_golem95
   use p9_udbar_neepgg_d15h3l1d, only: reconstruct_d15
   use p9_udbar_neepgg_d16h3l1, only: numerator_d16 => numerator_golem95
   use p9_udbar_neepgg_d16h3l1d, only: reconstruct_d16
   use p9_udbar_neepgg_d25h3l1, only: numerator_d25 => numerator_golem95
   use p9_udbar_neepgg_d25h3l1d, only: reconstruct_d25
   use p9_udbar_neepgg_d37h3l1, only: numerator_d37 => numerator_golem95
   use p9_udbar_neepgg_d37h3l1d, only: reconstruct_d37
   use p9_udbar_neepgg_d43h3l1, only: numerator_d43 => numerator_golem95
   use p9_udbar_neepgg_d43h3l1d, only: reconstruct_d43
   use p9_udbar_neepgg_d86h3l1, only: numerator_d86 => numerator_golem95
   use p9_udbar_neepgg_d86h3l1d, only: reconstruct_d86
   use p9_udbar_neepgg_d101h3l1, only: numerator_d101 => numerator_golem95
   use p9_udbar_neepgg_d101h3l1d, only: reconstruct_d101
   implicit none
   type(tensrec_info_group5), intent(out) :: coeffs
   !------#[ Diagram 15:
      if (tens_rec_by_derivatives) then
         call reconstruct_d15(coeffs)
      else
         call reconstruct1(numerator_d15, coeffs%coeffs_15)
      end if
   !------#] Diagram 15:
   !------#[ Diagram 16:
      if (tens_rec_by_derivatives) then
         call reconstruct_d16(coeffs)
      else
         call reconstruct3(numerator_d16, coeffs%coeffs_16)
      end if
   !------#] Diagram 16:
   !------#[ Diagram 25:
      if (tens_rec_by_derivatives) then
         call reconstruct_d25(coeffs)
      else
         call reconstruct3(numerator_d25, coeffs%coeffs_25)
      end if
   !------#] Diagram 25:
   !------#[ Diagram 37:
      if (tens_rec_by_derivatives) then
         call reconstruct_d37(coeffs)
      else
         call reconstruct2(numerator_d37, coeffs%coeffs_37)
      end if
   !------#] Diagram 37:
   !------#[ Diagram 43:
      if (tens_rec_by_derivatives) then
         call reconstruct_d43(coeffs)
      else
         call reconstruct2(numerator_d43, coeffs%coeffs_43)
      end if
   !------#] Diagram 43:
   !------#[ Diagram 86:
      if (tens_rec_by_derivatives) then
         call reconstruct_d86(coeffs)
      else
         call reconstruct4(numerator_d86, coeffs%coeffs_86)
      end if
   !------#] Diagram 86:
   !------#[ Diagram 101:
      if (tens_rec_by_derivatives) then
         call reconstruct_d101(coeffs)
      else
         call reconstruct3(numerator_d101, coeffs%coeffs_101)
      end if
   !------#] Diagram 101:
end subroutine reconstruct_group5
!---#] subroutine reconstruct_group5:
!---#[ subroutine reconstruct_group6:
subroutine     reconstruct_group6(coeffs)
   use tens_rec
   use p9_udbar_neepgg_config
   use p9_udbar_neepgg_groups, only: tensrec_info_group6
   use p9_udbar_neepgg_d23h3l1, only: numerator_d23 => numerator_golem95
   use p9_udbar_neepgg_d23h3l1d, only: reconstruct_d23
   use p9_udbar_neepgg_d84h3l1, only: numerator_d84 => numerator_golem95
   use p9_udbar_neepgg_d84h3l1d, only: reconstruct_d84
   implicit none
   type(tensrec_info_group6), intent(out) :: coeffs
   !------#[ Diagram 23:
      if (tens_rec_by_derivatives) then
         call reconstruct_d23(coeffs)
      else
         call reconstruct3(numerator_d23, coeffs%coeffs_23)
      end if
   !------#] Diagram 23:
   !------#[ Diagram 84:
      if (tens_rec_by_derivatives) then
         call reconstruct_d84(coeffs)
      else
         call reconstruct4(numerator_d84, coeffs%coeffs_84)
      end if
   !------#] Diagram 84:
end subroutine reconstruct_group6
!---#] subroutine reconstruct_group6:
!---#[ subroutine reconstruct_group7:
subroutine     reconstruct_group7(coeffs)
   use tens_rec
   use p9_udbar_neepgg_config
   use p9_udbar_neepgg_groups, only: tensrec_info_group7
   use p9_udbar_neepgg_d22h3l1, only: numerator_d22 => numerator_golem95
   use p9_udbar_neepgg_d22h3l1d, only: reconstruct_d22
   use p9_udbar_neepgg_d93h3l1, only: numerator_d93 => numerator_golem95
   use p9_udbar_neepgg_d93h3l1d, only: reconstruct_d93
   use p9_udbar_neepgg_d99h3l1, only: numerator_d99 => numerator_golem95
   use p9_udbar_neepgg_d99h3l1d, only: reconstruct_d99
   use p9_udbar_neepgg_d103h3l1, only: numerator_d103 => numerator_golem95
   use p9_udbar_neepgg_d103h3l1d, only: reconstruct_d103
   implicit none
   type(tensrec_info_group7), intent(out) :: coeffs
   !------#[ Diagram 22:
      if (tens_rec_by_derivatives) then
         call reconstruct_d22(coeffs)
      else
         call reconstruct3(numerator_d22, coeffs%coeffs_22)
      end if
   !------#] Diagram 22:
   !------#[ Diagram 93:
      if (tens_rec_by_derivatives) then
         call reconstruct_d93(coeffs)
      else
         call reconstruct4(numerator_d93, coeffs%coeffs_93)
      end if
   !------#] Diagram 93:
   !------#[ Diagram 99:
      if (tens_rec_by_derivatives) then
         call reconstruct_d99(coeffs)
      else
         call reconstruct3(numerator_d99, coeffs%coeffs_99)
      end if
   !------#] Diagram 99:
   !------#[ Diagram 103:
      if (tens_rec_by_derivatives) then
         call reconstruct_d103(coeffs)
      else
         call reconstruct3(numerator_d103, coeffs%coeffs_103)
      end if
   !------#] Diagram 103:
end subroutine reconstruct_group7
!---#] subroutine reconstruct_group7:
!---#[ subroutine reconstruct_group8:
subroutine     reconstruct_group8(coeffs)
   use tens_rec
   use p9_udbar_neepgg_config
   use p9_udbar_neepgg_groups, only: tensrec_info_group8
   use p9_udbar_neepgg_d91h3l1, only: numerator_d91 => numerator_golem95
   use p9_udbar_neepgg_d91h3l1d, only: reconstruct_d91
   implicit none
   type(tensrec_info_group8), intent(out) :: coeffs
   !------#[ Diagram 91:
      if (tens_rec_by_derivatives) then
         call reconstruct_d91(coeffs)
      else
         call reconstruct4(numerator_d91, coeffs%coeffs_91)
      end if
   !------#] Diagram 91:
end subroutine reconstruct_group8
!---#] subroutine reconstruct_group8:
!---#[ subroutine reconstruct_group9:
subroutine     reconstruct_group9(coeffs)
   use tens_rec
   use p9_udbar_neepgg_config
   use p9_udbar_neepgg_groups, only: tensrec_info_group9
   use p9_udbar_neepgg_d88h3l1, only: numerator_d88 => numerator_golem95
   use p9_udbar_neepgg_d88h3l1d, only: reconstruct_d88
   implicit none
   type(tensrec_info_group9), intent(out) :: coeffs
   !------#[ Diagram 88:
      if (tens_rec_by_derivatives) then
         call reconstruct_d88(coeffs)
      else
         call reconstruct4(numerator_d88, coeffs%coeffs_88)
      end if
   !------#] Diagram 88:
end subroutine reconstruct_group9
!---#] subroutine reconstruct_group9:
!---#[ subroutine reconstruct_group10:
subroutine     reconstruct_group10(coeffs)
   use tens_rec
   use p9_udbar_neepgg_config
   use p9_udbar_neepgg_groups, only: tensrec_info_group10
   use p9_udbar_neepgg_d27h3l1, only: numerator_d27 => numerator_golem95
   use p9_udbar_neepgg_d27h3l1d, only: reconstruct_d27
   use p9_udbar_neepgg_d83h3l1, only: numerator_d83 => numerator_golem95
   use p9_udbar_neepgg_d83h3l1d, only: reconstruct_d83
   implicit none
   type(tensrec_info_group10), intent(out) :: coeffs
   !------#[ Diagram 27:
      if (tens_rec_by_derivatives) then
         call reconstruct_d27(coeffs)
      else
         call reconstruct3(numerator_d27, coeffs%coeffs_27)
      end if
   !------#] Diagram 27:
   !------#[ Diagram 83:
      if (tens_rec_by_derivatives) then
         call reconstruct_d83(coeffs)
      else
         call reconstruct4(numerator_d83, coeffs%coeffs_83)
      end if
   !------#] Diagram 83:
end subroutine reconstruct_group10
!---#] subroutine reconstruct_group10:
!---#[ subroutine reconstruct_group11:
subroutine     reconstruct_group11(coeffs)
   use tens_rec
   use p9_udbar_neepgg_config
   use p9_udbar_neepgg_groups, only: tensrec_info_group11
   use p9_udbar_neepgg_d17h3l1, only: numerator_d17 => numerator_golem95
   use p9_udbar_neepgg_d17h3l1d, only: reconstruct_d17
   use p9_udbar_neepgg_d30h3l1, only: numerator_d30 => numerator_golem95
   use p9_udbar_neepgg_d30h3l1d, only: reconstruct_d30
   use p9_udbar_neepgg_d87h3l1, only: numerator_d87 => numerator_golem95
   use p9_udbar_neepgg_d87h3l1d, only: reconstruct_d87
   implicit none
   type(tensrec_info_group11), intent(out) :: coeffs
   !------#[ Diagram 17:
      if (tens_rec_by_derivatives) then
         call reconstruct_d17(coeffs)
      else
         call reconstruct3(numerator_d17, coeffs%coeffs_17)
      end if
   !------#] Diagram 17:
   !------#[ Diagram 30:
      if (tens_rec_by_derivatives) then
         call reconstruct_d30(coeffs)
      else
         call reconstruct3(numerator_d30, coeffs%coeffs_30)
      end if
   !------#] Diagram 30:
   !------#[ Diagram 87:
      if (tens_rec_by_derivatives) then
         call reconstruct_d87(coeffs)
      else
         call reconstruct4(numerator_d87, coeffs%coeffs_87)
      end if
   !------#] Diagram 87:
end subroutine reconstruct_group11
!---#] subroutine reconstruct_group11:
!---#[ subroutine reconstruct_group12:
subroutine     reconstruct_group12(coeffs)
   use tens_rec
   use p9_udbar_neepgg_config
   use p9_udbar_neepgg_groups, only: tensrec_info_group12
   use p9_udbar_neepgg_d85h3l1, only: numerator_d85 => numerator_golem95
   use p9_udbar_neepgg_d85h3l1d, only: reconstruct_d85
   implicit none
   type(tensrec_info_group12), intent(out) :: coeffs
   !------#[ Diagram 85:
      if (tens_rec_by_derivatives) then
         call reconstruct_d85(coeffs)
      else
         call reconstruct4(numerator_d85, coeffs%coeffs_85)
      end if
   !------#] Diagram 85:
end subroutine reconstruct_group12
!---#] subroutine reconstruct_group12:
end module p9_udbar_neepgg_golem95h3
